'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Tiles
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "Tiles") 
FLD_TOOLBARS = gfs.buildPath(FLD_HOME, "toolbars")
FLD_MAINTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Main")
FLD_TILESTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Tiles")

FLD_TILESMENU = gfs.buildPath(FLD_MAINTOOLBAR, "Tiles")

FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_IMAGES = gfs.buildPath(FLD_HOME, "images")
FLD_ICONS = gfs.buildPath(FLD_HOME, "icons")
FLD_TILES = gfs.buildPath(FLD_HOME, "tiles")
FLD_ACCENTS = gfs.buildPath(FLD_HOME, "accents")

'Skins
F_TILESKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles\tlbskin.ini")
F_MAINSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (main)\tlbskin.ini")
F_OVERLAYSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (overlay)\tlbskin.ini")
F_ICONSMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu icons)\tlbskin.ini")
F_TEXTMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu text)\tlbskin.ini")

F_TILEICON = gfs.buildPath(FLD_METROBARIMAGES, "tile.ico")
F_METROBARINI = gfs.buildPath(FLD_HOME, "metrobar.ini")

' Metrics
TILESIZE = 160  

' Hotkeys
HK_ACTIVATETILEBAR = "^%p"       ' CTRL+ALT+p
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_SHOWTILES = "^%+{right}"
HK_TEAROFF = "^t"

' Functions
function intToTileName(pInt)
    intToTileName = "Tile" & CStr(pInt)
end function    

sub refresh
    gws.sendkeys HK_ACTIVATETILEBAR
    wscript.sleep 20
    gws.sendkeys HK_REFRESH
end sub


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function lft(pString, pLength)

    lft = ""
    if pLength > 0 then
        lft = left(pString, pLength)
    elseif pLength < 0 then
        lft = left(pString, len(pString) + pLength)
    end if    

end function

function isTile(pPath)

    isTile = gfs.folderExists(pPath) AND isNumeric(gfs.getBaseName(pPath))

end function
    

Function IsValue(obj)
    ' Check whether a value has been returned.
    Dim tmp
    On Error Resume Next
    tmp = " " & obj
    If Err <> 0 Then
        IsValue = False
    Else
        IsValue = True
    End If
    On Error GoTo 0
End Function
'**** END INCLUDED FILE: classes\_global.vbs ****

'**** INCLUDED FILE: classes\_CFile.vbs ****


function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function
    
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    
'**** END INCLUDED FILE: classes\_CFile.vbs ****

'**** INCLUDED FILE: classes\_CINIFile.vbs ****
class CINIFile

    public aFile
    private lastIndex
    
    sub load(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile( pINIFile, 1, True )
        aFile = split(file.readAll(), vbCRLF)    
        file.close
        
    end sub


    sub save(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile(pINIFile, 2, false)
        sFile = join(aFile, vbCRLF)
        file.write(sFile)
        file.close
        
    end sub

    
    function getKeyValue(pSection, pKey)
    
        index = findKey(pSection, pKey)
        
        splitLine = split(aFile(index), "=")
        getKeyValue = ""
        if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
            getKeyValue = splitLine(1)
        end if    

    end function 'getKeyValue


    function getKeys(pKey)
    
        set getKeys = createObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if NOT trimmedLine = "" then
                splitLine = split(trimmedLine, "=")
                if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                    if not getKeys.exists(splitLine(1)) then
                        getKeys.add splitLine(1), ""
                    end if    
                end if    
            end if
        next
        
    end function 'getKeys
    

    
    function findKey(pSection, pKey)

        ' returns the line number of the found key, 0 if the keys does not exist
        ' and -1 if the section does not exist.
        
        ret = 0
        sectionFound = false
        index = -1
        for each line in aFile
            
            index = index + 1    
            trimmedLine = trim(line)             
            
            if NOT sectionFound then
          
                if replace(lcase(trimmedLine), lcase(pSection), "") = "[]" then
                    sectionFound = true
                end if    

            else
                
                if left(trimmedLine, 1) = "[" then
                    exit for
                else
                    splitLine = split(trimmedLine, "=")
                    
                    if ubound(splitLine) > -1 then
                        if lcase(trim(splitLine(0))) = lcase(pKey) then
                            ret = index
                            exit for
                        end if    
                    end if
                end if
            end if

        next

        lastIndex = index

        if not sectionFound then
            ret = -1
        end if    
            
        findKey = ret

    end function

    sub setKeyValue(pSection, pKey, pValue)
    
        index = findKey(pSection, pKey)
        if index > 0 then 
            splitLine = split(aFile(index), "=")
            if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                aFile(index) = splitLine(0) & "=" & pValue
            end if
        else
       
            if index = -1 then
                ubnd = ubound(aFile) + 2
                redim preserve aFile(ubnd)
                aFile(ubnd-1) = "[" & pSection & "]"
                aFile(ubnd) = pKey & "=" & pValue
                
            else 
                ubnd = ubound(aFile)
                redim preserve aFile(ubnd + 1)
                for i = ubnd to lastIndex + 1 step -1
                    aFile(i+1) = aFile(i) 
                next
                aFile(lastIndex+1) = pKey & "=" & pValue
            end if   
                
        end if            
    
    end sub 'setKeyValue

    
    public function findSections(pSection)
    
        set findSections = CreateObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if left(trimmedLine, len(pSection) + 1) = "[" & pSection then
                findSections.add mid(trimmedLine, 2, len(trimmedLine) - 2), ""
            end if
        next        

    end function
    
    function getSection(pSection)
    
        set getSection = createObject("Scripting.Dictionary")
        
        start = false
        for each line in aFile
            trimmedLine = trim(line)
            if start then
                if left(trimmedLine, 1) = "[" then
                    exit for
                end if
                if not trimmedLine = "" then
                    splitLine = split(trimmedLine, "=")
                    getSection.add splitLine(0), splitLine(1)
                 end if   
            end if
            if trimmedLine = "[" & pSection & "]" then
                start = true
            end if
        next
        
    end function

    
    public function nextSectionInstance(pSection)
    
        set sections = findSections(pSection)
        nextInstance = 0
        for each section in sections
            instance = replace(section, pSection, "")
            if isNumeric(instance) then
                if instance > nextInstance then
                    nextInstance = instance + 1
                end if
            end if
        next

        nextSectionInstance = pSection & nextInstance

                        
    end function    
              
    
    
    private sub Class_Initialize
        lastIndex = 0
    end sub

    
end class 'CINIFile


'**** END INCLUDED FILE: classes\_CINIFile.vbs ****


set script = new_CFile(wscript.scriptFullName)

FLD_TURNOFFPISKINS = gfs.buildPath(FLD_TLBHOME, "plugins\turnoff\skins\")

if not IM_isInstalled then
    reply = msgbox("This skin uses ImageMagick for image manipulation on-the-fly. Please install it first." & vbcrlf & vbcrlf & _
           "*** Click OK to go to the download page (www.imagemagick.org) ***", _
           vbOkCancel, "Tiles Install")
    if reply = vbOk then
        gws.run "http://www.imagemagick.org/script/binary-releases.php#windows"
    end if    
    wscript.quit
end if

if not gfs.folderExists(FLD_TURNOFFPISKINS) then
    reply = msgbox("This skin uses the Turn Off Computer TLB plugin. Please install it first:" & vbcrlf & vbcrlf & _
           "*** Click OK to go to the download page (www.truelaunchbar.com) ***", _
           vbOkCancel, "Tiles Install")
    if reply = vbOk then
        gws.run "http://www.truelaunchbar.com/plugins/turnoff.php"
    end if    
    wscript.quit
end if

copyFiles
createScriptWrappers
installFonts
installPluginSkins
setPaths
defineToolbars
createSendTo

msgbox "Tiles installation complete!", vbInformation, "Tiles Install Complete"

function IM_isInstalled

    dim msgs
    
    on error resume next
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert("logo:", "logo.gif")
    on error goto 0   
    
    if msgs = "640,480,GIF" then
        IM_isInstalled = true
    else
        IM_isInstalled = false
    end if    

end function

function copyFiles

    set fld = gfs.getFolder(gfs.buildPath(script.folder, "skins"))
    for each f in fld.subFolders
        gfs.copyFolder f, FLD_TLBSKINS & "/", true
    next

end function

function installFonts

    FONTSFOLDERID=20
    set objShell = CreateObject("Shell.Application")
    set objFolder = objShell.Namespace(FONTSFOLDERID)
    if objFolder is nothing then
        msgbox "NOT"
    end if    
        
    set ff = gfs.getFolder("fonts")

    for each file in ff.files
        objFolder.copyHere file.path, 20
    next
    
end function

function installPluginSkins

    gfs.copyFolder gfs.buildPath(script.folder, "plugins\turnoff\*"), FLD_TURNOFFPISKINS, true
    
    PSF = gfs.buildPath(FLD_TLBHOME, "plugins\tlbclock\skins\")
    if gfs.folderExists(PSF) then
       gfs.copyFolder gfs.buildPath(script.folder, "plugins\tlbclock\*"), PSF, true
    end if

    PSF = gfs.buildPath(FLD_TLBHOME, "plugins\calendar\skins\")
    if gfs.folderExists(PSF) then
       gfs.copyFolder gfs.buildPath(script.folder, "plugins\calendar\*"), PSF, true
    end if   
    
    PSF = gfs.buildPath(FLD_TLBHOME, "plugins\mediactl\skins\")
    if gfs.folderExists(PSF) then
       gfs.copyFolder gfs.buildPath(script.folder, "plugins\mediactl\*"), PSF, true
    end if   
       
    
end function   


sub createScriptWrappers

    createScriptWrapper gfs.buildPath(FLD_MAINTOOLBAR, "Show Tiles.wsf"), "showTiles.vbs"  
    createScriptWrapper gfs.buildPath(FLD_MAINTOOLBAR, "Hide Tiles.wsf"), "hideTiles.vbs"  

    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "New Tile.wsf"), "newTile.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Align Tiles.wsf"), "alignTiles.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Show Captions.wsf"), "showCaptions.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Hide Captions.wsf"), "hideCaptions.vbs"

end sub

sub setPaths

    set setupINI = new CINIFile
    setupINI.load gfs.buildPath(FLD_MAINTOOLBAR, "setup.ini")
    setupINI.setKeyValue "settings", "SkinFile", F_MAINSKIN
    setupINI.save gfs.buildPath(FLD_MAINTOOLBAR, "setup.ini")
    set setupINI = nothing

    set setupINI = new CINIFile
    setupINI.load gfs.buildPath(FLD_TILESTOOLBAR, "setup.ini")
    setupINI.setKeyValue "settings", "SkinFile", F_TILESKIN
    setupINI.save gfs.buildPath(FLD_TILESTOOLBAR, "setup.ini")
    set setupINI = nothing
    
end sub


sub defineToolbars

    tbName = "Tiles (main)"

    set xmlDoc = CreateObject("Microsoft.XMLDOM")
    xmlDoc.Async = "False"
'    msgbox F_TLBOPTIONS
    xmlDoc.Load(F_TLBOPTIONS)

    set toolbarNode=xmlDoc.selectSingleNode("//toolbars/toolbar[@name='" & tbName & "']")

    ' if the toolbar definition already exists then update it, else create it
    if not toolbarNode is nothing then
        toolbarNode.setAttribute "path", FLD_MAINTOOLBAR
    else        
        set toolbarsNode=xmlDoc.selectSingleNode("//toolbars")
        set newToolbarNode  = xmlDoc.CreateElement("toolbar")
        newToolbarNode.setAttribute "name", tbName
        newToolbarNode.setAttribute "path", FLD_MAINTOOLBAR
        toolbarsNode.AppendChild(newToolbarNode)
        set newToolbarNode = nothing
    end if
    set toolbarNode = nothing
    
    tbName = "Tiles"
    set toolbarNode=xmlDoc.selectSingleNode("//toolbars/toolbar[@name='" & tbName & "']")

    ' if the toolbar definition already exists then update it, else create it
    if not toolbarNode is nothing then
        toolbarNode.setAttribute "path", FLD_TILESTOOLBAR
    else        
        set toolbarsNode=xmlDoc.selectSingleNode("//toolbars")
        set newToolbarNode  = xmlDoc.CreateElement("toolbar")
        newToolbarNode.setAttribute "name", tbName
        newToolbarNode.setAttribute "path", FLD_TILESTOOLBAR
        toolbarsNode.AppendChild(newToolbarNode)
        set newToolbarNode = nothing
    end if
    set toolbarNode = nothing
    
    xmlDoc.save(F_TLBOPTIONS)

end sub

sub createSendTo

    set sc = gws.createShortcut(gfs.buildPath(gws.SpecialFolders("SendTo"), "Desktop (create tile).lnk"))
    sc.iconLocation = gfs.buildPath(FLD_IMAGES, "tile-dark.ico")
    sc.targetPath = gfs.buildPath(FLD_MAINTOOLBAR, "Tiles\New Tile.wsf")
    sc.save

end sub
