dim ws, fs
         
set ws = CreateObject("Wscript.Shell")
set fs = CreateObject("Scripting.FileSystemObject")

const forReading = 1
const forWriting = 2   
const overwrite = true
const createFile = true

thisFolder = fs.getParentFolderName(wscript.scriptFullName)

dim includedFiles

if wscript.arguments.count < 1 then
    
    msgbox "Drop a script on make.vbs to parse it.", vbInformation, "make.vbs" 
    wscript.quit(0)
    
end if     
    
for each arg in wscript.arguments
    set includedFiles = createObject("Scripting.Dictionary")
    make(arg)
    set includedFiles = nothing
next    

function make(pFile)

    sourceFolder = fs.getParentFolderName(pFile)
    sourceFileName =  fs.getFileName(pFile)

    if not left(sourceFileName, 1) = "_" then
        sourceFileName = sourceFileName & "_"
        fs.copyFile pFile, fs.buildPath(sourceFolder, sourceFileName), overwrite
    end if
    
    outFileName = right(sourceFileName, len(sourceFileName)-1)
    outFile = fs.buildPath(sourceFolder, outFileName) 
 
    Set f = fs.openTextFile(outFile, ForWriting, createFile)
    text = includeFile(pFile)

    f.Write text
    f.Close

    successMsg = "Success!" & vbCRLF & vbCRLF & "Created " & outFile
    if srcRenamed then
        successMsg = successMsg & vbCRLF & vbCRLF & "(source renamed to " & srcFilename & ")"
    end if        
    msgBox "Success!" & vbCRLF & vbCRLF & "Created " & outFile, vbInformation, "make " & outFileName

    
end function 'make
    
    
function hasTag(pString, pTag)

    hasTag = false
    hasTag = (left(trim(pString), len(pTag)) = pTag) 

end function 'hasTag    
    
    
function getTagValue(pString, pTag)

    getTagValue = ""
    if hasTag(pString, pTag) then
        getTagValue = trim(replace(trim(pString), pTag, ""))
    end if
    
end function 'getTagValue


function includeFile(pTextFile)

    dim f
    on error resume next
        set f = fs.openTextFile(pTextFile, ForReading)
        if (err.number <> 0) then
            on error goto 0
            msgbox "Error including file: " & vbCrLf & vbCrLf & pTextFile, vbCritical, fs.getFileName(pTextFile)
            wscript.quit(0)
        end if    
    on error goto 0
    strNewContents = ""

    includeLine = true
    do until f.atEndOfStream
    
        strLine = f.ReadLine
        usesValue = getTagValue(strLine, "#USES ")

        if NOT usesValue = "" then

            if NOT includedFiles.exists(usesValue) then
                includedFiles.add usesValue, usesValue
                strLine = "'**** INCLUDED FILE: " & usesValue & " ****" & vbCrLf
                usesFile = fs.buildPath(thisFolder, usesValue)
                strLine = strLine & includeFile(usesFile)
                strLine = strLine & "'**** END INCLUDED FILE: " & usesValue & " ****" & vbCrLf
            else
                strLine = ""
            end if
        else
            if hasTag(strLine, "'#EXCLUDE") then
                strLine = ""
                includeLine = NOT includeLine
            end if
        end if    

        if includeLine then strNewContents = strNewContents & strLine & vbCrLf

    loop
    
    f.Close

    includeFile = strNewContents
   
end function 'includeFile