#USES classes\_global.vbs
#USES classes\_CFile.vbs
#USES classes\_CTLBData.vbs
#USES classes\_CPoint.vbs


set script = new_CFile(wscript.scriptFullName)
set folder = gfs.getFolder(FLD_TILESTOOLBAR)
set subfolders = folder.subfolders 

set points = CreateObject("Scripting.Dictionary")

function isTile(pPath)

    isTile = gfs.folderExists(pPath) AND isNumeric(gfs.getBaseName(pPath))

end function
    
for each fld in subfolders

    if isTile(fld.path) then
        set tlbdata = load_CTLBData(gfs.buildPath(FLD_TILESTOOLBAR, fld.name & "\tlbdata.xml"))
        set options = tlbdata.getOptions
        x = options.getAttribute("tearoffX")
        y = options.getAttribute("tearoffY")
        points.add fld.name, x & "x" & y
        set tlbdata = nothing
        set options = nothing
    end if
next

minX = 99999
minY = 99999

for each point1 in points
    set p = new_CPoint(points.item(point1))
    if p.x < minX then minX = p.x
    if p.y < minY then minY = p.y
    set p = nothing
next     

if minX = 99999 then minX = 0
if minY = 99999 then minY = 0

'msgbox minX & "x" & minY

for each point2 in points
    set p = new_CPoint(points.item(point2))
    
    x1=cint((p.x-minX)/175)*175 + minX
    y1=cint((p.y-minY)/175)*175 + minY   
'    msgbox point2 & ":" & p.toString & "," & x1 & "x" & y1
    set tlbdata = load_CTLBData(gfs.buildPath(FLD_TILESTOOLBAR, point2 & "\tlbdata.xml"))    
    set options = tlbdata.getOptions
    options.setAttribute "tearoffX", x1
    options.setAttribute "tearoffY", y1
    tlbdata.save
    set tlbdata = nothing
next
  
gws.sendkeys HK_ACTIVATETILEBAR
wscript.sleep 200
gws.sendkeys HK_REFRESH
wscript.sleep 2000
gws.sendkeys HK_SHOWTILES
