#USES classes\_debug.vbs
#USES classes\_global.vbs
#USES classes\_xfso.vbs
#USES classes\_CTLBData.vbs
#USES classes\_CFile.vbs
#USES classes\_CTile.vbs
#USES classes\_CToolbar.vbs

function isAccent(pFile)
    isAccent = (gfs.getBaseName(gfs.getParentFolderName(pFile)) = "accents")
end function


set script = new_CFile(wscript.scriptFullName)
set tile = load_CTile(gfs.getParentFolderName(script.folder))
set toolbar = new_CToolbar(tile.folder)

F_TLBDATA = tile.tlbdata

if wscript.arguments.count <> 1 then 
    wscript.quit
end if 

set arg = new_CFile(wscript.arguments(0))

set icon = new_CFile(gfs.buildPath(gfs.buildPath(FLD_ICONS, arg.name), arg.name & ".png"))         

target = arg.fullpath

set mbg = new CMetrobarGraphics 

if arg.extension = "tlbplugin" then

    gfs.copyFile arg.fullPath, gfs.getParentFolderName(script.folder) & "/" , true
    gfs.deleteFolder(gfs.buildPath(gfs.getParentFolderName(script.folder), "Tile"))
 
else
   
    if arg.extension = "url" or arg.extension = "lnk" then    
        set targetShortcut = gws.createShortcut(arg.fullpath)
        target = targetShortcut.targetPath
    end if    

    if NOT target = "" then
       iconName = gfs.getbasename(target)
    else
       iconName = arg.name
    end if  
    
    set icon = new_CFile(gfs.buildPath(gfs.buildPath(FLD_ICONS, iconName), iconName & ".png"))     

    if not gfs.FolderExists(icon.folder) then
        gfs.createFolder icon.folder
    end if  

    set tlbdata = new CTLBData
    tlbdata.load F_TLBDATA    

    set currentTileImage = new_CFile(tlbdata.getItemImagePath("Tile"))

    if currentTileImage.name = "blank1" then 
        set tileColor = new_CFile(gxfs.getRandomFile(FLD_ACCENTS))
    else
        set tileColor = new_CFile(replace(currentTileImage.fullpath, "accents3", "accents"))
    end if

    if not gfs.fileExists(icon.fullpath) then
        return = gws.run("""" & FLD_SCRIPTS & "\getIcon.exe"" """ & target & """ """ & icon.fullpath & """", 0, true)    
    end if 
    
    gfs.copyFile icon.fullPath, tile.originalIcon, true
    mbg.resizeIcon icon.fullpath, "96x96", tile.icon
    gfs.copyFile tileColor.fullPath, tile.bg, true
    
    ret = mbg.createTile (tile.icon, arg.name, tile.bg, tile.btnImage) 

    gfs.copyFile tile.btnImage, tile.editBtnImage, true
    
    set link = new_CFile(gfs.buildPath(script.folder, "Tile.lnk"))

    tlbdata.setItemImagePath "Tile", tile.btnImage
    tlbdata.setItemImagePath "Edit", tile.editBtnImage    
    tlbdata.save
    set tlbdata = nothing
    
    set tlbdata = load_CTLBData(gfs.buildPath(link.folder, "tlbdata.xml"))
    tlbdata.setItemAttribute "Tile.lnk", "leftText", arg.name
    tlbdata.showItem "Edit Mode.wsf"
    tlbdata.save
    set tlbdata = nothing
    
    set shortcut = gws.createShortcut(link.fullpath)
    shortcut.targetpath = target
    shortcut.description = icon.name
    shortcut.save

end if

wscript.sleep 50
gws.sendkeys "{LEFT}"
gws.sendKeys HK_REFRESH

