#USES classes\_global.vbs
#USES classes\_CFile.vbs
#USES classes\_CINIFile.vbs

set script = new_CFile(wscript.scriptFullName)

FLD_TURNOFFPISKINS = gfs.buildPath(FLD_TLBHOME, "plugins\turnoff\skins\")

if not IM_isInstalled then
    reply = msgbox("This skin uses ImageMagick for image manipulation on-the-fly. Please install it first." & vbcrlf & vbcrlf & _
           "*** Click OK to go to the download page (www.imagemagick.org) ***", _
           vbOkCancel, "Tiles Install")
    if reply = vbOk then
        gws.run "http://www.imagemagick.org/script/binary-releases.php#windows"
    end if    
    wscript.quit
end if

if not gfs.folderExists(FLD_TURNOFFPISKINS) then
    reply = msgbox("This skin uses the Turn Off Computer TLB plugin. Please install it first:" & vbcrlf & vbcrlf & _
           "*** Click OK to go to the download page (www.truelaunchbar.com) ***", _
           vbOkCancel, "Tiles Install")
    if reply = vbOk then
        gws.run "http://www.truelaunchbar.com/plugins/turnoff.php"
    end if    
    wscript.quit
end if

copyFiles
createScriptWrappers
installFonts
installPluginSkins
setPaths
defineToolbars
createSendTo

msgbox "Tiles installation complete!", vbInformation, "Tiles Install Complete"

function IM_isInstalled

    dim msgs
    
    on error resume next
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert("logo:", "logo.gif")
    on error goto 0   
    
    if msgs = "640,480,GIF" then
        IM_isInstalled = true
    else
        IM_isInstalled = false
    end if    

end function

function copyFiles

    set fld = gfs.getFolder(gfs.buildPath(script.folder, "skins"))
    for each f in fld.subFolders
        gfs.copyFolder f, FLD_TLBSKINS & "/", true
    next

end function

function installFonts

    FONTSFOLDERID=20
    set objShell = CreateObject("Shell.Application")
    set objFolder = objShell.Namespace(FONTSFOLDERID)
    if objFolder is nothing then
        msgbox "NOT"
    end if    
        
    set ff = gfs.getFolder("fonts")

    for each file in ff.files
        objFolder.copyHere file.path, 20
    next
    
end function

function installPluginSkins

    gfs.copyFolder gfs.buildPath(script.folder, "plugins\turnoff\*"), FLD_TURNOFFPISKINS, true
    
    PSF = gfs.buildPath(FLD_TLBHOME, "plugins\tlbclock\skins\")
    if gfs.folderExists(PSF) then
       gfs.copyFolder gfs.buildPath(script.folder, "plugins\tlbclock\*"), PSF, true
    end if

    PSF = gfs.buildPath(FLD_TLBHOME, "plugins\calendar\skins\")
    if gfs.folderExists(PSF) then
       gfs.copyFolder gfs.buildPath(script.folder, "plugins\calendar\*"), PSF, true
    end if   
    
    PSF = gfs.buildPath(FLD_TLBHOME, "plugins\mediactl\skins\")
    if gfs.folderExists(PSF) then
       gfs.copyFolder gfs.buildPath(script.folder, "plugins\mediactl\*"), PSF, true
    end if   
       
    
end function   


sub createScriptWrappers

    createScriptWrapper gfs.buildPath(FLD_MAINTOOLBAR, "Show Tiles.wsf"), "showTiles.vbs"  
    createScriptWrapper gfs.buildPath(FLD_MAINTOOLBAR, "Hide Tiles.wsf"), "hideTiles.vbs"  

    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "New Tile.wsf"), "newTile.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Align Tiles.wsf"), "alignTiles.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Show Captions.wsf"), "showCaptions.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Hide Captions.wsf"), "hideCaptions.vbs"

end sub

sub setPaths

    set setupINI = new CINIFile
    setupINI.load gfs.buildPath(FLD_MAINTOOLBAR, "setup.ini")
    setupINI.setKeyValue "settings", "SkinFile", F_MAINSKIN
    setupINI.save gfs.buildPath(FLD_MAINTOOLBAR, "setup.ini")
    set setupINI = nothing

    set setupINI = new CINIFile
    setupINI.load gfs.buildPath(FLD_TILESTOOLBAR, "setup.ini")
    setupINI.setKeyValue "settings", "SkinFile", F_TILESKIN
    setupINI.save gfs.buildPath(FLD_TILESTOOLBAR, "setup.ini")
    set setupINI = nothing
    
end sub


sub defineToolbars

    tbName = "Tiles (main)"

    set xmlDoc = CreateObject("Microsoft.XMLDOM")
    xmlDoc.Async = "False"
'    msgbox F_TLBOPTIONS
    xmlDoc.Load(F_TLBOPTIONS)

    set toolbarNode=xmlDoc.selectSingleNode("//toolbars/toolbar[@name='" & tbName & "']")

    ' if the toolbar definition already exists then update it, else create it
    if not toolbarNode is nothing then
        toolbarNode.setAttribute "path", FLD_MAINTOOLBAR
    else        
        set toolbarsNode=xmlDoc.selectSingleNode("//toolbars")
        set newToolbarNode  = xmlDoc.CreateElement("toolbar")
        newToolbarNode.setAttribute "name", tbName
        newToolbarNode.setAttribute "path", FLD_MAINTOOLBAR
        toolbarsNode.AppendChild(newToolbarNode)
        set newToolbarNode = nothing
    end if
    set toolbarNode = nothing
    
    tbName = "Tiles"
    set toolbarNode=xmlDoc.selectSingleNode("//toolbars/toolbar[@name='" & tbName & "']")

    ' if the toolbar definition already exists then update it, else create it
    if not toolbarNode is nothing then
        toolbarNode.setAttribute "path", FLD_TILESTOOLBAR
    else        
        set toolbarsNode=xmlDoc.selectSingleNode("//toolbars")
        set newToolbarNode  = xmlDoc.CreateElement("toolbar")
        newToolbarNode.setAttribute "name", tbName
        newToolbarNode.setAttribute "path", FLD_TILESTOOLBAR
        toolbarsNode.AppendChild(newToolbarNode)
        set newToolbarNode = nothing
    end if
    set toolbarNode = nothing
    
    xmlDoc.save(F_TLBOPTIONS)

end sub

sub createSendTo

    set sc = gws.createShortcut(gfs.buildPath(gws.SpecialFolders("SendTo"), "Desktop (create tile).lnk"))
    sc.iconLocation = gfs.buildPath(FLD_IMAGES, "tile-dark.ico")
    sc.targetPath = gfs.buildPath(FLD_MAINTOOLBAR, "Tiles\New Tile.wsf")
    sc.save

end sub