#USES classes\_global.vbs

function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function
    
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    