#USES classes\_global.vbs
#USES classes\_CDisplay.vbs
#USES classes\_CFile.vbs
#USES classes\_CPoint.vbs

dim mbg
set mbg = new CMetrobarGraphics

class CMetrobarGraphics

    sub resizeTrash

        dim msgs
        F_TRASH = gfs.buildPath(FLD_METROBARTOOLBARS, "Metrobar Trash\~~images~~\btnimages\Trash.png")        
        imageWidth = (cint(Display.screenWidth / 2) - 160) * 2 - 6 
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert(F_TRASH, "-gravity", "center", "-crop", imageWidth & "x180+0+0!", "-background", "transparent", "-flatten", "+repage", F_TRASH) 
    '    msgbox msgs

    end sub

    function IMSuccess(pMsgs)
    
        a = split(pMsgs, ",")
        IMSuccess = isNumeric(a(0)) and isNumeric(a(1)) and (a(2) = "PNG") 
        
    end function
    
    
    function createOverlayImage(pLabel, pImageBG, pGravity, pOutFile)

        dim msgs
 
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.identify("-format", "%wx%h", pImageBG)
        
        set size = new_CPoint(msgs)
        set labelSize = size
        labelSize.y = int(size.y / 4)
        
        msgs = img.convert(pImageBG, "-background", "#00000077" , "-fill", "white", "-font", "Segoe-WP", "-size", labelSize.toString, "-gravity", "center", "label:" & pLabel,  _
                           "-gravity", pGravity, "-composite", "-write", "mpr:normal", "+delete", _
                           "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & pOutFile)    

                           
        if IMSuccess(msgs) then
            createOverlayImage = pOutFile
        else
            createOverlayImage = ""
        end if    
        
   '     msgbox msgs
        
    end function
    
    

 
    
    function createTile(pIconPath, pText, pTileColor, pTilePath)
      
        dim img 
        dim msgs

        createTile = false
        hover = FLD_IMAGES & "\hover.png"
        active = FLD_IMAGES & "\active.png"
        
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert(pTileColor, pIconPath, "-gravity", "center", "-composite", _
                           "-font", "Segoe-WP", "-pointsize", "16", "-fill", "white", "-gravity", "southwest", "-annotate", "+10+4", pText,  _
                           "-write", "mpr:normal", "+delete", _
                           hover, pIconPath, "-gravity", "center", "-composite", _
                           "-font", "Segoe-WP", "-pointsize", "16", "-fill", "white", "-gravity", "southwest", "-annotate", "+10+4", pText,  _
                           "-write", "mpr:hover", "+delete", _
                           active, pIconPath, "-gravity", "center", "-composite", _
                           "-font", "Segoe-WP", "-pointsize", "16", "-fill", "white", "-gravity", "southwest", "-annotate", "+10+4", pText,  _
                           "-write", "mpr:active", "+delete", _
                           "mpr:normal", "mpr:hover", "mpr:active", "-append", "-matte", "-bordercolor", "none", "-border", "0x0", pTilePath) 

        we "msgs1", msgs

        if msgs = "150,450,PNG" then
            createTile = true 
        end if
                
    end function 'createTile

    function makeTristate(pImage)
      
        dim img 
        dim msgs

        makeTristate = false
        hover = FLD_METROBARIMAGES & "\hover.png"
        active = FLD_METROBARIMAGES & "\active.png"
        
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert(pImage, "-matte", "-bordercolor", "none", "-border", "5x0", "-write", "mpr:normal", "+delete", _
                           "mpr:normal", "mpr:normal", "mpr:normal", "-append", "-matte", replace(pImage,"accents", "accents3")) 
        we "msgs1", msgs
        if msgs = "160,450,PNG" then
            makeTristate = true 
        end if
                
    end function 'makeTristate
    
    
    function resizeIcon(pIcon, pSize, pOut)
    
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert(pIcon, "-trim", "-resize", pSize & ">", "-size", "150x150", "xc:none", "+swap", "-gravity", "center", "-composite", pOut) 
    
    end function 'resizeIcon

    sub makePageTitle(pTitle, pOutFile)

        dim msgs

        set image = new_CFile(pOutFile)
        set imageS = new_CFile(gfs.buildPath(image.folder, image.name & "-S." & image.extension))
        set imageM = new_CFile(gfs.buildPath(image.folder, image.name & "-M." & image.extension))        
        set imageL = new_CFile(gfs.buildPath(image.folder, image.name & "-L." & image.extension))    

        size = "600x150"
        offset = "+0+0"
        
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert( "-size", size, "xc:none", "-font", "Segoe-WP-Light", "-pointsize", "58", "-fill", "#ffffffdd", "-gravity", "west", "-annotate", offset, pTitle, _
                            "-trim", "-bordercolor", "transparent", "-border", "-5", _
                            "-write", "mpr:normal", "+delete", _
                            "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & imageM.fullPath)
        
        msgs = img.convert( "-size", size, "xc:none", "-font", "Segoe-WP-Light", "-pointsize", "42", "-fill", "#ffffffdd", "-gravity", "west", "-annotate", offset, pTitle, _
                            "-trim", "-bordercolor", "transparent", "-border", "-5", _
                            "-write", "mpr:normal", "+delete", _
                            "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & imageS.fullPath)
        
        msgs = img.convert( "-size", size, "xc:none", "-font", "Segoe-WP-Light", "-pointsize", "78", "-fill", "#ffffffdd", "-gravity", "west", "-annotate", offset, pTitle, _
                            "-trim", "-bordercolor", "transparent", "-border", "-5", _
                            "-write", "mpr:normal", "+delete", _
                            "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & imageL.fullPath)
        

        '    msgbox msgs

    end sub
    
    public function extractIcon(pFilePath, pDestPath)
            dim ret
            extractIcon = false
            ret = gws.run("""" & FLD_SCRIPTS & "\getIcon.exe"" """ & pFilePath & """ """ & pDestPath & """", 0, true)    
            if gfs.fileExists(pDestPath) then
                extractIcon = true
            end if    
                
    end function
    
    public sub extractIcons(pSourceFile, pDestFolder)
        set sourceFile = new_CFile(pSourceFile)
        if instr("exe,dll,ocx,cpl", sourceFile.extension) > 0 then 
            set destFolder = new_CTLBFolder(pDestFolder)    
            if not destFolder.exists then
                destFolder.create
                ret = gws.run("""" & gfs.buildPath(FLD_SCRIPTS, "iconsext.exe") & """ /save """ & pFilePath & """ """ & destFolder & """", 0, true)    
            end if
        end if
    end sub
    
    function icoFile_getBestIconIndex(pIcoFile)
        dim res
        res = 0
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.identify("-format", "%p,%w_", pIcoFile )
        iconList = split(msgs, "_")
        largestFound = 0
        for i = 0 to UBOUND(iconList)
            if isNumeric(iconList(i)) then
                ic = split(iconList(i), ",")
                if cint(ic(1)) > largestFound then
                    largestFound = cint(ic(1))
                    res = ic(0)
                end if    
            end if
        next  
        icoFile_getBestIconIndex = res
     end function           

    sub ico2png(pIcoFile, pIndex, pPngFile)
        dim res
        res = false
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert(pIcoFile & "[" & pIndex &  "]", pPngFile )
    end sub           
     

end class