#USES classes\_xfso.vbs
#USES classes\_CFile.vbs
#USES classes\_CINIFile.vbs
#USES classes\_CFolder.vbs


public function new_CTLBData(ptlbdata)

        set new_CTLBData = new CTLBData  

        new_CTLBData.xmlDoc.loadXML("<?xml version=""1.0"" encoding=""utf-8""?>" & vbCRLF & _
            "<tlbdata>" & vbCRLF & _
            "    <folder name="""">" & vbCRLF & _
            "        <layout>" & vbCRLF & _
            "        </layout>" & vbCRLF & _
            "        <options skin="""" fontNameMI="""" fontSizeCAP=""0"" fontNameCAP="""" fontSizeTIT=""0"" fontNameTIT="""" disableGlass=""0"" disableTips=""0"" overlayFileName="""" overlayFlags=""34"" overlayTransparency=""255"" filterShowMask="""" filterHideMask=""""/>" & vbCRLF & _
            "    </folder>" & vbCRLF & _
            "</tlbdata>")        

        set new_CTLBData.options=new_CTLBData.xmlDoc.selectSingleNode("tlbdata/folder/options")     
      
        new_CTLBData.xmlDocPath = ptlbdata
            
end function


public function load_CTLBData(ptlbdata) 

    set load_CTLBData = new CTLBData
    load_CTLBData.load(ptlbdata)         
    load_CTLBData.xmlDocPath = ptlbdata
     
end function  
    

    

class CTLBData

    public function newItem(pName)
    
        set element = xmlDoc.createElement("item")
        element.setAttribute "name", pName    

        set newItem = element    

    end function
    
'   ** Public Methods

    public sub save
        xmlDoc.save(xmlDocPath)
    end sub

    public sub saveAs(pFile)
        xmlDoc.save(pFile)
    end sub
    
  
    function findItemByName(pItemName)
        set findItemByName=xmlDoc.selectSingleNode("//layout/item[@name='" & pItemName & "']")        
    end function

    public function getItemAttribute(pItemName, pAttribute)

        set itemNode=findItemByName(pItemName)
        getItemAttribute = itemNode.getAttribute(pAttribute)
  
    end function

    public function getItemImagePath(pItemName)
        
        getItemImagePath = getItemAttribute(pItemName, "ImagePath")
    
    end function

    
    public sub setOption(pOptionName, pValue)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        optionsNode.setAttribute pOptionName, pValue
    
    end sub

    public function getOption(pOptionName)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        getOption = optionsNode.getAttribute(pOptionName)
        
    end function
   
    public function getOptions
        
        set getOptions=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        
    end function
     
   
    public function toggleOption(pOptionName)
        
        curval = getOption(pOptionName)
        if curval = "1" then
            nxtval = "0"
        else
            nxtval = "1"
        end if
        setOption pOptionName, nxtval

    end function
      
    
    
    public sub setItemAttribute(pItemName, pAttribute, pValue)
        
        set itemNode=findItemByName(pItemName)
        itemNode.setAttribute pAttribute, pValue
    
    end sub

    public sub setItemImagePath(pItemName, pValue)

        setItemAttribute pItemName, "ImagePath", pValue

    end sub
    
    public sub setCaption(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        itemNode.setAttribute "showCaption", "2"    
        set captionNode = xmlDoc.createElement("caption")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public sub setIconLocation(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        set captionNode = xmlDoc.createElement("IconLocation")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public function getChildText(pItemName, pElementName)
        
        getChildText = ""
        dim itemNode
        set itemNode=findItemByName(pItemName)
        for each node in itemNode.childNodes
            if node.nodeName = pElementName then
                getChildText = node.text
            end if
        next           
       
    end function
        

    public sub removeCaption(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showCaption", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "caption" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub

    public sub removeDescription(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showDescription", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "description" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub
    
    public sub hideItem(pItemName)

        setItemAttribute pItemName, "hidden", "1"
        
    end sub

    public sub showItem(pItemName)

        setItemAttribute pItemName, "hidden", "0"
     
    end sub

    public sub load(ptlbdata) 

        xmlDoc.Load(ptlbdata)         
        xmlDocPath = ptlbdata
         
    end sub  
    
'   ** Public Properties
    
    public xmlDoc
    public xmlDocPath
    public options
    
'   ** Private Methods

    private sub Class_Initialize()
    
        set xmlDoc = createObject("Microsoft.XMLDOM")
        xmlDoc.Async = false
        xmlDoc.setProperty "SelectionLanguage", "XPath"
        
    end sub


    public function createItem(pItemName)

        set lItem = xmlDoc.createElement("item")
        lItem.setAttribute "name", pItemName
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set createItem = layoutNode.appendChild(lItem)        

    end function
    
    public function appendItem(pXMLElement)

        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set appendItem = layoutNode.appendChild(pXMLElement)        

    end function
        
    
    
    public function createItemElement(pItemName)

        set createItemElement = xmlDoc.createElement("item")
        createItemElement.setAttribute "name", pItemName
'        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
'        set createItem = layoutNode.appendChild(newItem)        

    end function
        
    
    public function createItem2(pItemName, pImagePath)

        set newItem = xmlDoc.createElement("item")
        newItem.setAttribute "name", pItemName
        newItem.setAttribute "ImagePath", pImagePath
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        layoutNode.appendChild(newItem)        
        set createItem2 = newItem
        
        
    end function
    
    public sub createCaption(pNode, pCaptionText)
        
        dim newItem
        set newItem = xmlDoc.createElement("caption")
        newItem.text = pCaptionText
        pNode.appendChild(newItem)
        
    end sub

    public sub appendChildTextNode(pNode, pTextNodeName, pText)

        dim newItem
        set newItem = xmlDoc.createElement(pTextNodeName)
        newItem.text = pText
        pNode.appendChild(newItem)
       
    end sub

    
    public function createItemInstance(pItemName, pImagePath)

        itemBaseName = gfs.getBaseName(pItemName)
        itemExtension = gfs.getExtensionName(pItemName)
        set itemNodes = xmlDoc.selectNodes("//layout/item[contains(@name, '" & itemBaseName & "')]")

        usedItems = ""
        for each node in itemNodes
            usedItems = usedItems & "," & node.getAttribute("name")
        next
        
        i = 1
      
        do
            if itemExtension = "" then
                itemName = itemBaseName & i
            else
                itemName = itemBaseName & i & "." & itemExtension
            end if
            i = i + 1
        loop while instr(usedItems, itemName)

        set createItemInstance = createItem3(itemName, pImagePath, false)
        save

    end function 'createItemInstance
         
    function getIconLocation(pItemName)
        ret = ""   
        set subFolder = new_CFolder(replace(xmlDocPath, "tlbdata.xml", lft(pItemName, -4)))
'        msgbox subFolder.toString
        if gxfs.isFolder(subFolder.path) then
            set setupINI = new_CFile(gfs.buildPath(subFolder.path, "setup.ini"))
'            setupINI.show
            if setupINI.exists then
                set sini = new CINIFile
                sini.load(setupINI.fullpath)
                ret = sini.getKeyValue("icon", "icon")
                set sini = nothing
            end if
        else
            ret = me.getChildText(pItemName, "IconLocation")
        end if
        getIconLocation = ret
    
    end function

end class 'CTLBDATA