#USES classes\_global.vbs
#USES classes\_CTLBFolder.vbs
#USES classes\_CTLBData.vbs
#USES classes\_CMetrobarGraphics.vbs
#USES classes\_CPoint.vbs

function new_CTile(pfullPath)

    set this = new CTile
    this.fullPath = gxfs.newInstance(pfullPath)
    set new_CTile = this
  
end function 'new_CTile

function load_CTile(pfullPath)

    set this = new CTile
    this.fullPath = pfullPath
    set load_CTile = this
  
end function 'load_CTile

class CTile

    public fullPath

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function

    public function tlbdata
        tlbdata = gfs.buildPath(fullPath, "tlbdata.xml")
    end function
    
    public function icon
        icon = gfs.buildPath(fullPath, "~~images~~\icon.png")
    end function
    
    public function originalIcon
        originalIcon = gfs.buildPath(fullPath, "~~images~~\originalIcon.png")
    end function    
    
    public function bg
        bg = gfs.buildPath(fullPath, "~~images~~\bg.png")
    end function    
  
    public function btnImage
        btnImage = gfs.buildPath(fullPath, "~~images~~\btnImage.png")
    end function    

    public function editBtnImage
        editBtnImage = gfs.buildPath(fullPath, "~~images~~\editBtnImage.png")
    end function    
    
    public function shortcut
        shortcut = gfs.buildPath(fullPath, "Tile\Tile.lnk")
    end function    
           
        
    private sub createTile

        set tile = new_CTLBFolder(gxfs.newInstance(fullPath)) 

        set tileTLBData = new_CTLBData(tile.tlbdata)
        tileTLBData.options.setAttribute "skin", F_TILESKIN
        tileTLBData.options.setAttribute "IconSize", "96"       
        tileTLBData.options.setAttribute "ViewStyle", "2"
        tileTLBData.options.setAttribute "ViewMode", "2" 
'        tileTLBData.options.setAttribute "skinvalid", "1"
        tileTLBData.options.setAttribute "menuAlign", "8466"
        tileTLBData.options.setAttribute "showCaption", "1"
        tileTLBData.options.setAttribute "tearoffOnTop", "0"        
        tileTLBData.options.setAttribute "Columns", "3"      

        set tileItem = tileTLBData.newItem("Tile")
        tileItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "blank1.png")
        tileTLBData.appendItem(tileItem)

        set editItem = tileTLBData.newItem("Edit")
        editItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "blank1.png")
        editItem.setAttribute "hidden", "1"
        tileTLBData.appendItem(editItem)

        tile.create   

        imagesFolder = gfs.buildPath(tile.path, "~~images~~")
        gfs.createFolder(imagesFolder)        
        gxfs.hideFolder(imagesFolder)


        tileTLBData.save
        set tileTLBData = nothing
            
    end sub

    private sub createTileOverlay

        set overlay = new_CTLBFolder(gfs.buildPath(fullPath, "Tile"))
        set overlayTLBData = new_CTLBData(overlay.tlbdata)
        overlayTLBData.options.setAttribute "skin", F_OVERLAYSKIN
        overlayTLBData.options.setAttribute "IconSize", "96"       
        overlayTLBData.options.setAttribute "ViewStyle", "2"
        overlayTLBData.options.setAttribute "ViewMode", "2" 
        overlayTLBData.options.setAttribute "skinvalid", "1"
        overlayTLBData.options.setAttribute "menuAlign", "102"
        overlayTLBData.options.setAttribute "showCaption", "0"
        overlayTLBData.options.setAttribute "Columns", "8"      

        set showCaptionItem = overlayTLBData.newItem("Show Caption.wsf")
        showCaptionItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "showcaption.png")
        overlayTLBData.appendItem(showCaptionItem)        

        set editButtonItem = overlayTLBData.newItem("Edit Mode.wsf")
        editButtonItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "editButton.png")
        editButtonItem.setAttribute "hidden", "1"
        overlayTLBData.appendItem(editButtonItem)           

        set item = overlayTLBData.newItem("Delete Tile.lnk")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "deleteTile.png")
        overlayTLBData.appendItem(item)
        set item = nothing
        
        set separator = overlayTLBData.newItem("**")
        overlayTLBData.appendItem(separator)

        set hotSpotItem2 = overlayTLBData.newItem("Tile.lnk")
        hotSpotItem2.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot.png")
        hotSpotItem2.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem2)        
 
        overlay.create
        overlayTLBData.save
        set overlayTLBData = nothing

        createScriptWrapper gfs.buildPath(overlay.path, "Show Caption.wsf"), "showCaption.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Edit Mode.wsf"), "editMode.vbs"
'        createScriptWrapper gfs.buildPath(overlay.path, "Delete Tile.wsf"), "deleteTile.vbs"

        set sc = gws.createShortcut(gfs.buildPath(overlay.path, "Delete Tile.lnk"))    
        sc.targetpath = """" & gfs.buildPath(FLD_SCRIPTS, "deleteTile.vbs") & """"
        sc.arguments =  """" & me.fullpath & """"
        sc.workingdirectory = FLD_HOME
        sc.save
        
        set hotSpotScript = new_CFile(gfs.buildPath(overlay.path, "Tile.wsf"))
        createScriptWrapper hotSpotScript.fullPath, "setTile.vbs"
        hotSpotScript.setHidden

        set hotSpotShortcut = gws.createShortcut(gfs.buildPath(overlay.path, "Tile.lnk"))
        hotSpotShortcut.targetPath = hotSpotScript.fullPath
        hotSpotShortcut.description = "Drop something here to create a tile"
        hotSpotShortcut.save        
        set hotSpotShortcut = nothing

    end sub

    
    private sub createEditOverlay

        set overlay = new_CTLBFolder(gfs.buildPath(fullPath, "Edit"))
        set overlayTLBData = new_CTLBData(overlay.tlbdata)
        overlayTLBData.options.setAttribute "skin", F_OVERLAYSKIN
        overlayTLBData.options.setAttribute "IconSize", "96"       
        overlayTLBData.options.setAttribute "ViewStyle", "2"
        overlayTLBData.options.setAttribute "ViewMode", "2" 
        overlayTLBData.options.setAttribute "skinvalid", "1"
        overlayTLBData.options.setAttribute "menuAlign", "102"
        overlayTLBData.options.setAttribute "showCaption", "0"
        overlayTLBData.options.setAttribute "Columns", "8"      

        set item = overlayTLBData.newItem("Show Caption.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "showcaption.png")
        overlayTLBData.appendItem(item)
        set item = nothing

        set item = overlayTLBData.newItem("Keep.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "tick.png")
        overlayTLBData.appendItem(item)      
        set item = nothing
        
        set item = overlayTLBData.newItem("Discard.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "cross.png")
        overlayTLBData.appendItem(item)
        set item = nothing        

        set item = overlayTLBData.newItem("Add alternate.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "plus.png")
        overlayTLBData.appendItem(item)          
        item.setAttribute "hidden", "1"
        set item = nothing
        
        set separator = overlayTLBData.newItem("**")
        overlayTLBData.appendItem(separator)

        set hotSpotItem1 = overlayTLBData.newItem("Size")
        hotSpotItem1.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot1.png")
        hotSpotItem1.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem1)        

        set hotSpotItem2 = overlayTLBData.newItem("Icon")
        hotSpotItem2.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot2.png")
        hotSpotItem2.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem2)        

        set hotSpotItem3 = overlayTLBData.newItem("Color")
        hotSpotItem3.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot3.png")
        hotSpotItem3.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem3)
        
        set separator = overlayTLBData.newItem("**")
        overlayTLBData.appendItem(separator)        

        set hotSpotItem4 = overlayTLBData.newItem("Caption")
        hotSpotItem4.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot4.png")
        hotSpotItem4.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem4)            
        
  
        overlay.create
        overlayTLBData.save
        set overlayTLBData = nothing

 
        createScriptWrapper gfs.buildPath(overlay.path, "Show Caption.wsf"), "showCaption.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Keep.wsf"), "keep.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Discard.wsf"), "discard.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Add alternate.wsf"), "addAlternate.vbs"
        
'         set hotSpotScript = new_CFile(gfs.buildPath(overlay.path, "hotSpot1.wsf"))
'         createScriptWrapper hotSpotScript.fullPath, "null.vbs"
'        hotSpotScript.setHidden
         
         createSizeFolder(gfs.buildPath(overlay.path, "Size"))
         createIconFolder(gfs.buildPath(overlay.path, "Icon"))
         createColorFolder(gfs.buildPath(overlay.path, "Color"))
         createCaptionFolder(gfs.buildPath(overlay.path, "Caption"))
         
     end sub

     private sub createColorFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)
         newFolderTLBData.options.setAttribute "skin", F_ICONSMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "26"       
         newFolderTLBData.options.setAttribute "disableTips", "1"
         newFolderTLBData.options.setAttribute "ViewStyle", "1"
         newFolderTLBData.options.setAttribute "ViewMode", "4" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "8482"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "3"      
         

         newFolderTLBData.save
         
     end sub

     private sub createCaptionFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)
         newFolderTLBData.options.setAttribute "skin", F_TEXTMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "24"       
 '        newFolderTLBData.options.setAttribute "ViewStyle", "2"
         newFolderTLBData.options.setAttribute "ViewMode", "5" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "13056"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "1"      
         
         newFolderTLBData.save
     
     end sub

     
     
     private sub createSizeFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)

         newFolderTLBData.options.setAttribute "skin", F_TEXTMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "16"       
'        newFolderTLBData.options.setAttribute "ViewStyle", "2"
         newFolderTLBData.options.setAttribute "ViewMode", "5" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "8465"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "1"    

        newFolderTLBData.options.setAttribute "maxMenuWidth", "125"
        newFolderTLBData.options.setAttribute "maxMenuHeight", "0"
        newFolderTLBData.options.setAttribute "minMenuWidth", "125"
        newFolderTLBData.options.setAttribute "minMenuHeight", "0"         
         
         set item = newFolderTLBData.newItem("Over size.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing        
        
         set item = newFolderTLBData.newItem("Full.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing
         
         set item = newFolderTLBData.newItem("Normal.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing
         
         set item = newFolderTLBData.newItem("Small.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing

         newFolderTLBData.save

         createScriptWrapper gfs.buildPath(newFolder.path, "Full.wsf"), "full.vbs"
         createScriptWrapper gfs.buildPath(newFolder.path, "Normal.wsf"), "normal.vbs"
         createScriptWrapper gfs.buildPath(newFolder.path, "Small.wsf"), "small.vbs"         
         createScriptWrapper gfs.buildPath(newFolder.path, "Over size.wsf"), "overSize.vbs"   
         
    end sub
    
    
      private sub createIconFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)
         newFolderTLBData.options.setAttribute "skin", F_TEXTMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "48"       
         newFolderTLBData.options.setAttribute "disableTips", "1"
         newFolderTLBData.options.setAttribute "ViewStyle", "1"
         newFolderTLBData.options.setAttribute "ViewMode", "4" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "13056"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "1"    
         
         newFolderTLBData.save
     
    end sub
       
    
    public sub create

        createTile

        createTileOverlay
       
        createEditOverlay

        
    end sub


    public sub setTarget(pTarget)

        dim target
        set target = new_CFile(pTarget)

        dim link
        set link = nothing
        if target.extension = "lnk" or target.extension = "url" then
            set link = gws.createShortcut(target.fullpath)
            set app = new_CFile(link.targetPath)
        else
            set app = target
        end if    

        iconLoc = target.fullPath
        
        set iconLocObj = new_CFile(iconLoc)
        
        dim extractedIconLocation
        set extractedIconLocation = new_CFile(gfs.buildPath(gfs.buildPath(FLD_ICONS, app.name), app.name & ".png"))
        
        if not gfs.FolderExists(extractedIconLocation.folder) then
            gfs.createFolder extractedIconLocation.folder
        end if  
        
        if iconLocObj.extension = "ico" then
            iconIndex = mbg.icoFile_getBestIconIndex(iconLocObj.fullpath)
            mbg.ico2png iconLocObj.fullpath, iconIndex, extractedIconLocation.fullPath
        else
            if not mbg.extractIcon(iconLoc, extractedIconLocation.fullpath) then
                msgbox "no icons found in  " & icon.FullPath
            end if
        end if

        set tileColor = new_CFile(gxfs.getRandomFile(FLD_ACCENTS))        
        
        dim tlbdata3
        set tlbdata3 = new CTLBData
        tlbdata3.load me.tlbdata  

        
        gfs.copyFile extractedIconLocation.fullPath, me.originalIcon, true
        mbg.resizeIcon extractedIconLocation.fullpath, "96x96", me.icon
        gfs.copyFile tileColor.fullPath, me.bg, true
        ret = mbg.createTile (me.icon, target.name, me.bg, me.btnImage) 

    
        gfs.copyFile me.btnImage, me.editBtnImage, true

        set link = new_CFile(gfs.buildPath(me.fullPath, "Tile\Tile.lnk"))

        tlbdata3.setItemImagePath "Tile", me.btnImage
        tlbdata3.setItemImagePath "Edit", me.editBtnImage    

        tlbdata3.save
        set tlbdata3 = nothing
            
        set tlbdata3 = load_CTLBData(gfs.buildPath(link.folder, "tlbdata.xml"))
        tlbdata3.setItemAttribute "Tile.lnk", "leftText", target.name
        tlbdata3.showItem "Edit Mode.wsf"
        tlbdata3.save
        set tlbdata3 = nothing

        set shortcut2 = gws.createShortcut(link.fullpath)
        shortcut2.targetpath = target.fullpath
        shortcut2.description = target.name
        shortcut2.save

        
    end sub
    
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "icon: " & icon & vbcrlf & _
                    "bg: " & bg & vbcrlf & _
                    "btnImage: " & btnImage & vbcrlf & _
                    "fullPath: " & fullPath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTile" 
        
    end sub 'show
           
end class 


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
