'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Tiles
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "Tiles") 
FLD_TOOLBARS = gfs.buildPath(FLD_HOME, "toolbars")
FLD_MAINTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Main")
FLD_TILESTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Tiles")

FLD_TILESMENU = gfs.buildPath(FLD_MAINTOOLBAR, "Tiles")

FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_IMAGES = gfs.buildPath(FLD_HOME, "images")
FLD_ICONS = gfs.buildPath(FLD_HOME, "icons")
FLD_TILES = gfs.buildPath(FLD_HOME, "tiles")
FLD_ACCENTS = gfs.buildPath(FLD_HOME, "accents")

'Skins
F_TILESKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles\tlbskin.ini")
F_MAINSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (main)\tlbskin.ini")
F_OVERLAYSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (overlay)\tlbskin.ini")
F_ICONSMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu icons)\tlbskin.ini")
F_TEXTMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu text)\tlbskin.ini")

F_TILEICON = gfs.buildPath(FLD_METROBARIMAGES, "tile.ico")
F_METROBARINI = gfs.buildPath(FLD_HOME, "metrobar.ini")

' Metrics
TILESIZE = 160  

' Hotkeys
HK_ACTIVATETILEBAR = "^%p"       ' CTRL+ALT+p
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_SHOWTILES = "^%+{right}"
HK_TEAROFF = "^t"

' Functions
function intToTileName(pInt)
    intToTileName = "Tile" & CStr(pInt)
end function    

sub refresh
    gws.sendkeys HK_ACTIVATETILEBAR
    wscript.sleep 20
    gws.sendkeys HK_REFRESH
end sub


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function lft(pString, pLength)

    lft = ""
    if pLength > 0 then
        lft = left(pString, pLength)
    elseif pLength < 0 then
        lft = left(pString, len(pString) + pLength)
    end if    

end function

function isTile(pPath)

    isTile = gfs.folderExists(pPath) AND isNumeric(gfs.getBaseName(pPath))

end function
    

Function IsValue(obj)
    ' Check whether a value has been returned.
    Dim tmp
    On Error Resume Next
    tmp = " " & obj
    If Err <> 0 Then
        IsValue = False
    Else
        IsValue = True
    End If
    On Error GoTo 0
End Function
'**** END INCLUDED FILE: classes\_global.vbs ****


refresh
'wscript.sleep 2000
'gws.sendkeys "^%{RIGHT}"
