'**** INCLUDED FILE: classes\_debug.vbs ****
dbg = 0

sub we (name, value)
    if dbg = 1 then
        wscript.echo(name & ": " & value)
    end if
end sub
'**** END INCLUDED FILE: classes\_debug.vbs ****

'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Tiles
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "Tiles") 
FLD_TOOLBARS = gfs.buildPath(FLD_HOME, "toolbars")
FLD_MAINTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Main")
FLD_TILESTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Tiles")

FLD_TILESMENU = gfs.buildPath(FLD_MAINTOOLBAR, "Tiles")

FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_IMAGES = gfs.buildPath(FLD_HOME, "images")
FLD_ICONS = gfs.buildPath(FLD_HOME, "icons")
FLD_TILES = gfs.buildPath(FLD_HOME, "tiles")
FLD_ACCENTS = gfs.buildPath(FLD_HOME, "accents")

'Skins
F_TILESKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles\tlbskin.ini")
F_MAINSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (main)\tlbskin.ini")
F_OVERLAYSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (overlay)\tlbskin.ini")
F_ICONSMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu icons)\tlbskin.ini")
F_TEXTMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu text)\tlbskin.ini")

F_TILEICON = gfs.buildPath(FLD_METROBARIMAGES, "tile.ico")
F_METROBARINI = gfs.buildPath(FLD_HOME, "metrobar.ini")

' Metrics
TILESIZE = 160  

' Hotkeys
HK_ACTIVATETILEBAR = "^%p"       ' CTRL+ALT+p
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_SHOWTILES = "^%+{right}"
HK_TEAROFF = "^t"

' Functions
function intToTileName(pInt)
    intToTileName = "Tile" & CStr(pInt)
end function    

sub refresh
    gws.sendkeys HK_ACTIVATETILEBAR
    wscript.sleep 20
    gws.sendkeys HK_REFRESH
end sub


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function lft(pString, pLength)

    lft = ""
    if pLength > 0 then
        lft = left(pString, pLength)
    elseif pLength < 0 then
        lft = left(pString, len(pString) + pLength)
    end if    

end function

function isTile(pPath)

    isTile = gfs.folderExists(pPath) AND isNumeric(gfs.getBaseName(pPath))

end function
    

Function IsValue(obj)
    ' Check whether a value has been returned.
    Dim tmp
    On Error Resume Next
    tmp = " " & obj
    If Err <> 0 Then
        IsValue = False
    Else
        IsValue = True
    End If
    On Error GoTo 0
End Function
'**** END INCLUDED FILE: classes\_global.vbs ****

'#USES classes\_xfso.vbs
'#USES classes\_CMetroTLB.vbs
'**** INCLUDED FILE: classes\_CTLBData.vbs ****
'**** INCLUDED FILE: classes\_xfso.vbs ****

set gxfs = new xfso

class xfso

    public function isFolder(pPath)
    
        fileExists = gfs.fileExists(pPath)
        folderExists = gfs.folderExists(pPath)    
        ret = false
        if gfs.fileExists(pPath) then
            ret = false
        elseif gfs.folderExists(pPath) then
            ret = true
        elseif gfs.getExtensionName(pPath) = "" then
            ret = true
        else
            ret = false
        end if    
        isFolder = ret
        
    end function
    

    function newFileInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.fileExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i & "." & gfs.getExtensionName(pPath))
        loop
        newFileInstance = nxt
    
    end function
    
    function newFolderInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.folderExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i)
        loop
        newFolderInstance = nxt

    end function

    function newInstance(pPath)

        if isFolder(pPath) then
            newInstance = newFolderInstance(pPath)    
        else
            newInstance = newFileInstance(pPath)
        end if

    end function

    function getParentFolderByName(pPath, pParentFolderName)

        dim fs
        set fs = createObject("Scripting.FileSystemObject")
        
        folderPath = pPath   
        do until fs.getBaseName(folderPath) = pParentFolderName or folderPath = "" 
            folderPath = fs.getParentFolderName(folderPath)   
        loop 
        
        if folderPath = pPath then folderPath = ""
        getParentFolderByName = folderPath
       
    end function 'getParentFolderByName   
  
  
    function getRandomFile(pFolder)
        
        dim f, fs
        set fs = CreateObject("Scripting.FileSystemObject")         
        set f = fs.getFolder(pFolder)
        
        Randomize
        i = CInt((Rnd() * f.Files.Count) + 1)
        j = 1 
        
        For Each fi In f.Files
           If j >= i Then 
              we "fi", fi
              Exit For
           End If
           j = j + 1
        Next

        getRandomFile = fi.path
        
    end function 'getRandomFile
  
     public sub TextFile_replaceString(pTextFile, pFind, pReplace)

        Set f = gfs.openTextFile(pTextFile, 1)

        strText = f.readAll
        f.close
        strNewText = replace(strText, pFind, pReplace)

        set f = gfs.openTextFile(pTextFile, 2)
        f.writeLine strNewText
        f.close
    
    end sub 'TextFile_replaceString

'    public function newFileInstance(pPath)
'
'        if not gfs.fileExists(pPath) then
'            f = pPath
'        else    
'            basePath = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath))
'            ext = gfs.getExtensionName(pPath)
'            i = 0
'            do
'                i = i + 1
'                f = basePath & i & "." & ext
'            loop while gfs.fileExists(f)
'        end if
'        newFileInstance = f
'
'    end function 'newFileInstance
    
    public sub wmiRename(pFilePath, pNewPath)

        fname = replace(pFilePath, "\", "\\")
        strComputer = "."
        Set objWMIService = GetObject _
            ("winmgmts:" & "!\\" & strComputer & "\root\cimv2")
        Set colFiles = objWMIService.ExecQuery _
            ("Select * from CIM_DataFile where Name = " _
                & "'" & fname & "'")
        For Each objFile in colFiles
            objfile.rename(pNewPath)
        Next    
    
    end sub
    
    public sub hideFile(pFile)
    
        set f = gfs.getFile(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub
        
    public sub hideFolder(pFile)
    
        set f = gfs.getFolder(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub

    function findFiles(pFolder)
    
        set dicFiles = createObject("Scripting.Dictionary")
        objStartFolder = pFolder

        Set objFolder = gfs.GetFolder(objStartFolder)
        Set colFiles = objFolder.Files
        For Each objFile in colFiles
            dicFiles.add objFile.path, ""
        Next

        ShowSubfolders gfs.GetFolder(objStartFolder)

        for each f in dicFiles
            m = m & f & vbcrlf
        next
        Set filetxt = gfs.CreateTextFile("c:\somefile3.txt", True)
        path = gfs.GetAbsolutePathName("c:\somefile3.txt")
        getname = gfs.GetFileName(path)
        filetxt.Write(m)
        filetxt.Close
        
        set findFiles = dicFiles
        
    end function
        
    Sub ShowSubFolders(Folder)
        For Each Subfolder in Folder.SubFolders
            Set objFolder = gfs.GetFolder(Subfolder.Path)
            Set colFiles = objFolder.Files
            For Each objFile in colFiles
                dicFiles.add objFile.path, ""
            Next
            ShowSubFolders Subfolder
        Next
    End Sub
    
end class 'xfso
'**** END INCLUDED FILE: classes\_xfso.vbs ****

'**** INCLUDED FILE: classes\_CFile.vbs ****


function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function
    
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    
'**** END INCLUDED FILE: classes\_CFile.vbs ****

'**** INCLUDED FILE: classes\_CINIFile.vbs ****
class CINIFile

    public aFile
    private lastIndex
    
    sub load(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile( pINIFile, 1, True )
        aFile = split(file.readAll(), vbCRLF)    
        file.close
        
    end sub


    sub save(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile(pINIFile, 2, false)
        sFile = join(aFile, vbCRLF)
        file.write(sFile)
        file.close
        
    end sub

    
    function getKeyValue(pSection, pKey)
    
        index = findKey(pSection, pKey)
        
        splitLine = split(aFile(index), "=")
        getKeyValue = ""
        if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
            getKeyValue = splitLine(1)
        end if    

    end function 'getKeyValue


    function getKeys(pKey)
    
        set getKeys = createObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if NOT trimmedLine = "" then
                splitLine = split(trimmedLine, "=")
                if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                    if not getKeys.exists(splitLine(1)) then
                        getKeys.add splitLine(1), ""
                    end if    
                end if    
            end if
        next
        
    end function 'getKeys
    

    
    function findKey(pSection, pKey)

        ' returns the line number of the found key, 0 if the keys does not exist
        ' and -1 if the section does not exist.
        
        ret = 0
        sectionFound = false
        index = -1
        for each line in aFile
            
            index = index + 1    
            trimmedLine = trim(line)             
            
            if NOT sectionFound then
          
                if replace(lcase(trimmedLine), lcase(pSection), "") = "[]" then
                    sectionFound = true
                end if    

            else
                
                if left(trimmedLine, 1) = "[" then
                    exit for
                else
                    splitLine = split(trimmedLine, "=")
                    
                    if ubound(splitLine) > -1 then
                        if lcase(trim(splitLine(0))) = lcase(pKey) then
                            ret = index
                            exit for
                        end if    
                    end if
                end if
            end if

        next

        lastIndex = index

        if not sectionFound then
            ret = -1
        end if    
            
        findKey = ret

    end function

    sub setKeyValue(pSection, pKey, pValue)
    
        index = findKey(pSection, pKey)
        if index > 0 then 
            splitLine = split(aFile(index), "=")
            if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                aFile(index) = splitLine(0) & "=" & pValue
            end if
        else
       
            if index = -1 then
                ubnd = ubound(aFile) + 2
                redim preserve aFile(ubnd)
                aFile(ubnd-1) = "[" & pSection & "]"
                aFile(ubnd) = pKey & "=" & pValue
                
            else 
                ubnd = ubound(aFile)
                redim preserve aFile(ubnd + 1)
                for i = ubnd to lastIndex + 1 step -1
                    aFile(i+1) = aFile(i) 
                next
                aFile(lastIndex+1) = pKey & "=" & pValue
            end if   
                
        end if            
    
    end sub 'setKeyValue

    
    public function findSections(pSection)
    
        set findSections = CreateObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if left(trimmedLine, len(pSection) + 1) = "[" & pSection then
                findSections.add mid(trimmedLine, 2, len(trimmedLine) - 2), ""
            end if
        next        

    end function
    
    function getSection(pSection)
    
        set getSection = createObject("Scripting.Dictionary")
        
        start = false
        for each line in aFile
            trimmedLine = trim(line)
            if start then
                if left(trimmedLine, 1) = "[" then
                    exit for
                end if
                if not trimmedLine = "" then
                    splitLine = split(trimmedLine, "=")
                    getSection.add splitLine(0), splitLine(1)
                 end if   
            end if
            if trimmedLine = "[" & pSection & "]" then
                start = true
            end if
        next
        
    end function

    
    public function nextSectionInstance(pSection)
    
        set sections = findSections(pSection)
        nextInstance = 0
        for each section in sections
            instance = replace(section, pSection, "")
            if isNumeric(instance) then
                if instance > nextInstance then
                    nextInstance = instance + 1
                end if
            end if
        next

        nextSectionInstance = pSection & nextInstance

                        
    end function    
              
    
    
    private sub Class_Initialize
        lastIndex = 0
    end sub

    
end class 'CINIFile


'**** END INCLUDED FILE: classes\_CINIFile.vbs ****

'**** INCLUDED FILE: classes\_CFolder.vbs ****


function new_CFolder(pFile)

    set new_CFolder = new CFolder
    new_CFolder.path = pFile

end function 'create


class CFolder

    public path

    public function name
        name = gfs.getBaseName(path)
    end function
    
    public sub write

        wscript.echo(toString)
        
    end sub 'write
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "path: " & path

    end function 'toString

    
    public function exists
    
        exists = gfs.folderExists(fullPath)
        
    end function    

    
    public sub create
    
        gfs.createFolder(path)
    
    end sub
 
    
    public function findFiles

        set objFSO = createObject("Scripting.FileSystemObject")
        set dicFiles = createObject("Scripting.Dictionary")
       
        set objFolder = objFSO.getFolder(path)
        set colFiles = objFolder.Files
        for each objFile in colFiles
            dicFiles.add objFile.path, ""
            msgbox "objFile:" & objFile.path
        next

        set colFolders = objFolder.subFolders
        for each objSubFolder in colFolders
        msgbox objSubFolder.path
            set subFolder = new_CFolder(objSubFolder.path)
            set dicSubFolderFiles = subFolder.findFiles
            for each subFolderFile in dicSubFolderFiles
                msgbox "XxXX" & subFolderFile.path
                dicFiles.add subFolderFile.path , ""
            next
            set subFolder = nothing
        next
    
        set findFiles = dicFiles
        
    end function 'findFiles



    
    
end class 'CFolder    
'**** END INCLUDED FILE: classes\_CFolder.vbs ****



public function new_CTLBData(ptlbdata)

        set new_CTLBData = new CTLBData  

        new_CTLBData.xmlDoc.loadXML("<?xml version=""1.0"" encoding=""utf-8""?>" & vbCRLF & _
            "<tlbdata>" & vbCRLF & _
            "    <folder name="""">" & vbCRLF & _
            "        <layout>" & vbCRLF & _
            "        </layout>" & vbCRLF & _
            "        <options skin="""" fontNameMI="""" fontSizeCAP=""0"" fontNameCAP="""" fontSizeTIT=""0"" fontNameTIT="""" disableGlass=""0"" disableTips=""0"" overlayFileName="""" overlayFlags=""34"" overlayTransparency=""255"" filterShowMask="""" filterHideMask=""""/>" & vbCRLF & _
            "    </folder>" & vbCRLF & _
            "</tlbdata>")        

        set new_CTLBData.options=new_CTLBData.xmlDoc.selectSingleNode("tlbdata/folder/options")     
      
        new_CTLBData.xmlDocPath = ptlbdata
            
end function


public function load_CTLBData(ptlbdata) 

    set load_CTLBData = new CTLBData
    load_CTLBData.load(ptlbdata)         
    load_CTLBData.xmlDocPath = ptlbdata
     
end function  
    

    

class CTLBData

    public function newItem(pName)
    
        set element = xmlDoc.createElement("item")
        element.setAttribute "name", pName    

        set newItem = element    

    end function
    
'   ** Public Methods

    public sub save
        xmlDoc.save(xmlDocPath)
    end sub

    public sub saveAs(pFile)
        xmlDoc.save(pFile)
    end sub
    
  
    function findItemByName(pItemName)
        set findItemByName=xmlDoc.selectSingleNode("//layout/item[@name='" & pItemName & "']")        
    end function

    public function getItemAttribute(pItemName, pAttribute)

        set itemNode=findItemByName(pItemName)
        getItemAttribute = itemNode.getAttribute(pAttribute)
  
    end function

    public function getItemImagePath(pItemName)
        
        getItemImagePath = getItemAttribute(pItemName, "ImagePath")
    
    end function

    
    public sub setOption(pOptionName, pValue)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        optionsNode.setAttribute pOptionName, pValue
    
    end sub

    public function getOption(pOptionName)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        getOption = optionsNode.getAttribute(pOptionName)
        
    end function
   
    public function getOptions
        
        set getOptions=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        
    end function
     
   
    public function toggleOption(pOptionName)
        
        curval = getOption(pOptionName)
        if curval = "1" then
            nxtval = "0"
        else
            nxtval = "1"
        end if
        setOption pOptionName, nxtval

    end function
      
    
    
    public sub setItemAttribute(pItemName, pAttribute, pValue)
        
        set itemNode=findItemByName(pItemName)
        itemNode.setAttribute pAttribute, pValue
    
    end sub

    public sub setItemImagePath(pItemName, pValue)

        setItemAttribute pItemName, "ImagePath", pValue

    end sub
    
    public sub setCaption(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        itemNode.setAttribute "showCaption", "2"    
        set captionNode = xmlDoc.createElement("caption")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public sub setIconLocation(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        set captionNode = xmlDoc.createElement("IconLocation")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public function getChildText(pItemName, pElementName)
        
        getChildText = ""
        dim itemNode
        set itemNode=findItemByName(pItemName)
        for each node in itemNode.childNodes
            if node.nodeName = pElementName then
                getChildText = node.text
            end if
        next           
       
    end function
        

    public sub removeCaption(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showCaption", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "caption" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub

    public sub removeDescription(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showDescription", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "description" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub
    
    public sub hideItem(pItemName)

        setItemAttribute pItemName, "hidden", "1"
        
    end sub

    public sub showItem(pItemName)

        setItemAttribute pItemName, "hidden", "0"
     
    end sub

    public sub load(ptlbdata) 

        xmlDoc.Load(ptlbdata)         
        xmlDocPath = ptlbdata
         
    end sub  
    
'   ** Public Properties
    
    public xmlDoc
    public xmlDocPath
    public options
    
'   ** Private Methods

    private sub Class_Initialize()
    
        set xmlDoc = createObject("Microsoft.XMLDOM")
        xmlDoc.Async = false
        xmlDoc.setProperty "SelectionLanguage", "XPath"
        
    end sub


    public function createItem(pItemName)

        set lItem = xmlDoc.createElement("item")
        lItem.setAttribute "name", pItemName
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set createItem = layoutNode.appendChild(lItem)        

    end function
    
    public function appendItem(pXMLElement)

        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set appendItem = layoutNode.appendChild(pXMLElement)        

    end function
        
    
    
    public function createItemElement(pItemName)

        set createItemElement = xmlDoc.createElement("item")
        createItemElement.setAttribute "name", pItemName
'        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
'        set createItem = layoutNode.appendChild(newItem)        

    end function
        
    
    public function createItem2(pItemName, pImagePath)

        set newItem = xmlDoc.createElement("item")
        newItem.setAttribute "name", pItemName
        newItem.setAttribute "ImagePath", pImagePath
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        layoutNode.appendChild(newItem)        
        set createItem2 = newItem
        
        
    end function
    
    public sub createCaption(pNode, pCaptionText)
        
        dim newItem
        set newItem = xmlDoc.createElement("caption")
        newItem.text = pCaptionText
        pNode.appendChild(newItem)
        
    end sub

    public sub appendChildTextNode(pNode, pTextNodeName, pText)

        dim newItem
        set newItem = xmlDoc.createElement(pTextNodeName)
        newItem.text = pText
        pNode.appendChild(newItem)
       
    end sub

    
    public function createItemInstance(pItemName, pImagePath)

        itemBaseName = gfs.getBaseName(pItemName)
        itemExtension = gfs.getExtensionName(pItemName)
        set itemNodes = xmlDoc.selectNodes("//layout/item[contains(@name, '" & itemBaseName & "')]")

        usedItems = ""
        for each node in itemNodes
            usedItems = usedItems & "," & node.getAttribute("name")
        next
        
        i = 1
      
        do
            if itemExtension = "" then
                itemName = itemBaseName & i
            else
                itemName = itemBaseName & i & "." & itemExtension
            end if
            i = i + 1
        loop while instr(usedItems, itemName)

        set createItemInstance = createItem3(itemName, pImagePath, false)
        save

    end function 'createItemInstance
         
    function getIconLocation(pItemName)
        ret = ""   
        set subFolder = new_CFolder(replace(xmlDocPath, "tlbdata.xml", lft(pItemName, -4)))
'        msgbox subFolder.toString
        if gxfs.isFolder(subFolder.path) then
            set setupINI = new_CFile(gfs.buildPath(subFolder.path, "setup.ini"))
'            setupINI.show
            if setupINI.exists then
                set sini = new CINIFile
                sini.load(setupINI.fullpath)
                ret = sini.getKeyValue("icon", "icon")
                set sini = nothing
            end if
        else
            ret = me.getChildText(pItemName, "IconLocation")
        end if
        getIconLocation = ret
    
    end function

end class 'CTLBDATA
'**** END INCLUDED FILE: classes\_CTLBData.vbs ****

'**** INCLUDED FILE: classes\_CMetrobarGraphics.vbs ****

'**** INCLUDED FILE: classes\_CDisplay.vbs ****


dim Display
set Display = new CDisplay ' Ready-made object

class CDisplay

'** PUBLIC **
    
    public screenWidth, screenHeight
    
'** PRIVATE **

    private sub Class_Initialize

        Set objWMIService = GetObject("Winmgmts:\\.\root\cimv2") 
        Set colItems = objWMIService.ExecQuery("Select * From Win32_DesktopMonitor where DeviceID = 'DesktopMonitor1'",,0) 
        For Each objItem in colItems 
            screenWidth = objItem.ScreenWidth 
            screenHeight = objItem.ScreenHeight 
        Next 
    
    end sub
         
         
end class
'**** END INCLUDED FILE: classes\_CDisplay.vbs ****


'**** INCLUDED FILE: classes\_CPoint.vbs ****
public function toInt(pIn)
    ' safely converts a string to integer
    dim ret
    ret = ""
    for i = 1 to len(pIn)
        if isNumeric(mid(pIn, i, 1)) then
            ret = ret + mid(pIn, i, 1)
        end if   
    next
    toInt = cint(ret)
end function



public function new_CPoint(xy)

    xxy = replace(xy, " ", "")
    point = split(xxy, "x")
    set this = new CPoint
    this.x = toInt(point(0)) ' had issues with CINT here so uses custom toInt instead
    this.y = toInt(point(1))
    
    set new_CPoint = this
    
end function

class CPoint

    public x
    public y

    public function toString

        toString = x & "x" & y
        
    end function
 
    private sub Class_Initialize
        x = 0
        y = 0
    end sub
 
end class
'**** END INCLUDED FILE: classes\_CPoint.vbs ****


dim mbg
set mbg = new CMetrobarGraphics

class CMetrobarGraphics

    sub resizeTrash

        dim msgs
        F_TRASH = gfs.buildPath(FLD_METROBARTOOLBARS, "Metrobar Trash\~~images~~\btnimages\Trash.png")        
        imageWidth = (cint(Display.screenWidth / 2) - 160) * 2 - 6 
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert(F_TRASH, "-gravity", "center", "-crop", imageWidth & "x180+0+0!", "-background", "transparent", "-flatten", "+repage", F_TRASH) 
    '    msgbox msgs

    end sub

    function IMSuccess(pMsgs)
    
        a = split(pMsgs, ",")
        IMSuccess = isNumeric(a(0)) and isNumeric(a(1)) and (a(2) = "PNG") 
        
    end function
    
    
    function createOverlayImage(pLabel, pImageBG, pGravity, pOutFile)

        dim msgs
 
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.identify("-format", "%wx%h", pImageBG)
        
        set size = new_CPoint(msgs)
        set labelSize = size
        labelSize.y = int(size.y / 4)
        
        msgs = img.convert(pImageBG, "-background", "#00000077" , "-fill", "white", "-font", "Segoe-WP", "-size", labelSize.toString, "-gravity", "center", "label:" & pLabel,  _
                           "-gravity", pGravity, "-composite", "-write", "mpr:normal", "+delete", _
                           "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & pOutFile)    

                           
        if IMSuccess(msgs) then
            createOverlayImage = pOutFile
        else
            createOverlayImage = ""
        end if    
        
   '     msgbox msgs
        
    end function
    
    

 
    
    function createTile(pIconPath, pText, pTileColor, pTilePath)
      
        dim img 
        dim msgs

        createTile = false
        hover = FLD_IMAGES & "\hover.png"
        active = FLD_IMAGES & "\active.png"
        
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert(pTileColor, pIconPath, "-gravity", "center", "-composite", _
                           "-font", "Segoe-WP", "-pointsize", "16", "-fill", "white", "-gravity", "southwest", "-annotate", "+10+4", pText,  _
                           "-write", "mpr:normal", "+delete", _
                           hover, pIconPath, "-gravity", "center", "-composite", _
                           "-font", "Segoe-WP", "-pointsize", "16", "-fill", "white", "-gravity", "southwest", "-annotate", "+10+4", pText,  _
                           "-write", "mpr:hover", "+delete", _
                           active, pIconPath, "-gravity", "center", "-composite", _
                           "-font", "Segoe-WP", "-pointsize", "16", "-fill", "white", "-gravity", "southwest", "-annotate", "+10+4", pText,  _
                           "-write", "mpr:active", "+delete", _
                           "mpr:normal", "mpr:hover", "mpr:active", "-append", "-matte", "-bordercolor", "none", "-border", "0x0", pTilePath) 

        we "msgs1", msgs

        if msgs = "150,450,PNG" then
            createTile = true 
        end if
                
    end function 'createTile

    function makeTristate(pImage)
      
        dim img 
        dim msgs

        makeTristate = false
        hover = FLD_METROBARIMAGES & "\hover.png"
        active = FLD_METROBARIMAGES & "\active.png"
        
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert(pImage, "-matte", "-bordercolor", "none", "-border", "5x0", "-write", "mpr:normal", "+delete", _
                           "mpr:normal", "mpr:normal", "mpr:normal", "-append", "-matte", replace(pImage,"accents", "accents3")) 
        we "msgs1", msgs
        if msgs = "160,450,PNG" then
            makeTristate = true 
        end if
                
    end function 'makeTristate
    
    
    function resizeIcon(pIcon, pSize, pOut)
    
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert(pIcon, "-trim", "-resize", pSize & ">", "-size", "150x150", "xc:none", "+swap", "-gravity", "center", "-composite", pOut) 
    
    end function 'resizeIcon

    sub makePageTitle(pTitle, pOutFile)

        dim msgs

        set image = new_CFile(pOutFile)
        set imageS = new_CFile(gfs.buildPath(image.folder, image.name & "-S." & image.extension))
        set imageM = new_CFile(gfs.buildPath(image.folder, image.name & "-M." & image.extension))        
        set imageL = new_CFile(gfs.buildPath(image.folder, image.name & "-L." & image.extension))    

        size = "600x150"
        offset = "+0+0"
        
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert( "-size", size, "xc:none", "-font", "Segoe-WP-Light", "-pointsize", "58", "-fill", "#ffffffdd", "-gravity", "west", "-annotate", offset, pTitle, _
                            "-trim", "-bordercolor", "transparent", "-border", "-5", _
                            "-write", "mpr:normal", "+delete", _
                            "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & imageM.fullPath)
        
        msgs = img.convert( "-size", size, "xc:none", "-font", "Segoe-WP-Light", "-pointsize", "42", "-fill", "#ffffffdd", "-gravity", "west", "-annotate", offset, pTitle, _
                            "-trim", "-bordercolor", "transparent", "-border", "-5", _
                            "-write", "mpr:normal", "+delete", _
                            "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & imageS.fullPath)
        
        msgs = img.convert( "-size", size, "xc:none", "-font", "Segoe-WP-Light", "-pointsize", "78", "-fill", "#ffffffdd", "-gravity", "west", "-annotate", offset, pTitle, _
                            "-trim", "-bordercolor", "transparent", "-border", "-5", _
                            "-write", "mpr:normal", "+delete", _
                            "mpr:normal", "mpr:normal", "mpr:normal", "-append", "PNG32:" & imageL.fullPath)
        

        '    msgbox msgs

    end sub
    
    public function extractIcon(pFilePath, pDestPath)
            dim ret
            extractIcon = false
            ret = gws.run("""" & FLD_SCRIPTS & "\getIcon.exe"" """ & pFilePath & """ """ & pDestPath & """", 0, true)    
            if gfs.fileExists(pDestPath) then
                extractIcon = true
            end if    
                
    end function
    
    public sub extractIcons(pSourceFile, pDestFolder)
        set sourceFile = new_CFile(pSourceFile)
        if instr("exe,dll,ocx,cpl", sourceFile.extension) > 0 then 
            set destFolder = new_CTLBFolder(pDestFolder)    
            if not destFolder.exists then
                destFolder.create
                ret = gws.run("""" & gfs.buildPath(FLD_SCRIPTS, "iconsext.exe") & """ /save """ & pFilePath & """ """ & destFolder & """", 0, true)    
            end if
        end if
    end sub
    
    function icoFile_getBestIconIndex(pIcoFile)
        dim res
        res = 0
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.identify("-format", "%p,%w_", pIcoFile )
        iconList = split(msgs, "_")
        largestFound = 0
        for i = 0 to UBOUND(iconList)
            if isNumeric(iconList(i)) then
                ic = split(iconList(i), ",")
                if cint(ic(1)) > largestFound then
                    largestFound = cint(ic(1))
                    res = ic(0)
                end if    
            end if
        next  
        icoFile_getBestIconIndex = res
     end function           

    sub ico2png(pIcoFile, pIndex, pPngFile)
        dim res
        res = false
        set img = createObject("ImageMagickObject.MagickImage.1")
        msgs = img.convert(pIcoFile & "[" & pIndex &  "]", pPngFile )
    end sub           
     

end class
'**** END INCLUDED FILE: classes\_CMetrobarGraphics.vbs ****


'**** INCLUDED FILE: classes\_CTile.vbs ****

'**** INCLUDED FILE: classes\_CTLBFolder.vbs ****



function new_CTLBFolder(pPath)

    set this = new CTLBFolder
    this.path = pPath
    set new_CTLBFolder = this
    
end function 'new_CTLBFolder

class CTLBFolder

    public path    
    
    public function name 
        name = gfs.getBaseName(path)
    end function

    public function folder 
        folder = gfs.getParentFolderName(path)
    end function
    
    public function tlbdata
        tlbdata = gfs.buildPath(path, "tlbdata.xml")
    end function    

    public function setup
        setup = gfs.buildPath(path, "setup.ini")
    end function    

    
    public sub create

        gfs.createFolder(path)
        
    end sub 'create

    public function toString

        toString =  "path: " & path & vbcrlf & _
                    "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "setup: " & setup

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTLBFolder" 
        
    end sub 'show
   
end class    
'**** END INCLUDED FILE: classes\_CTLBFolder.vbs ****





function new_CTile(pfullPath)

    set this = new CTile
    this.fullPath = gxfs.newInstance(pfullPath)
    set new_CTile = this
  
end function 'new_CTile

function load_CTile(pfullPath)

    set this = new CTile
    this.fullPath = pfullPath
    set load_CTile = this
  
end function 'load_CTile

class CTile

    public fullPath

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function

    public function tlbdata
        tlbdata = gfs.buildPath(fullPath, "tlbdata.xml")
    end function
    
    public function icon
        icon = gfs.buildPath(fullPath, "~~images~~\icon.png")
    end function
    
    public function originalIcon
        originalIcon = gfs.buildPath(fullPath, "~~images~~\originalIcon.png")
    end function    
    
    public function bg
        bg = gfs.buildPath(fullPath, "~~images~~\bg.png")
    end function    
  
    public function btnImage
        btnImage = gfs.buildPath(fullPath, "~~images~~\btnImage.png")
    end function    

    public function editBtnImage
        editBtnImage = gfs.buildPath(fullPath, "~~images~~\editBtnImage.png")
    end function    
    
    public function shortcut
        shortcut = gfs.buildPath(fullPath, "Tile\Tile.lnk")
    end function    
           
        
    private sub createTile

        set tile = new_CTLBFolder(gxfs.newInstance(fullPath)) 

        set tileTLBData = new_CTLBData(tile.tlbdata)
        tileTLBData.options.setAttribute "skin", F_TILESKIN
        tileTLBData.options.setAttribute "IconSize", "96"       
        tileTLBData.options.setAttribute "ViewStyle", "2"
        tileTLBData.options.setAttribute "ViewMode", "2" 
'        tileTLBData.options.setAttribute "skinvalid", "1"
        tileTLBData.options.setAttribute "menuAlign", "8466"
        tileTLBData.options.setAttribute "showCaption", "1"
        tileTLBData.options.setAttribute "tearoffOnTop", "0"        
        tileTLBData.options.setAttribute "Columns", "3"      

        set tileItem = tileTLBData.newItem("Tile")
        tileItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "blank1.png")
        tileTLBData.appendItem(tileItem)

        set editItem = tileTLBData.newItem("Edit")
        editItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "blank1.png")
        editItem.setAttribute "hidden", "1"
        tileTLBData.appendItem(editItem)

        tile.create   

        imagesFolder = gfs.buildPath(tile.path, "~~images~~")
        gfs.createFolder(imagesFolder)        
        gxfs.hideFolder(imagesFolder)


        tileTLBData.save
        set tileTLBData = nothing
            
    end sub

    private sub createTileOverlay

        set overlay = new_CTLBFolder(gfs.buildPath(fullPath, "Tile"))
        set overlayTLBData = new_CTLBData(overlay.tlbdata)
        overlayTLBData.options.setAttribute "skin", F_OVERLAYSKIN
        overlayTLBData.options.setAttribute "IconSize", "96"       
        overlayTLBData.options.setAttribute "ViewStyle", "2"
        overlayTLBData.options.setAttribute "ViewMode", "2" 
        overlayTLBData.options.setAttribute "skinvalid", "1"
        overlayTLBData.options.setAttribute "menuAlign", "102"
        overlayTLBData.options.setAttribute "showCaption", "0"
        overlayTLBData.options.setAttribute "Columns", "8"      

        set showCaptionItem = overlayTLBData.newItem("Show Caption.wsf")
        showCaptionItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "showcaption.png")
        overlayTLBData.appendItem(showCaptionItem)        

        set editButtonItem = overlayTLBData.newItem("Edit Mode.wsf")
        editButtonItem.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "editButton.png")
        editButtonItem.setAttribute "hidden", "1"
        overlayTLBData.appendItem(editButtonItem)           

        set item = overlayTLBData.newItem("Delete Tile.lnk")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "deleteTile.png")
        overlayTLBData.appendItem(item)
        set item = nothing
        
        set separator = overlayTLBData.newItem("**")
        overlayTLBData.appendItem(separator)

        set hotSpotItem2 = overlayTLBData.newItem("Tile.lnk")
        hotSpotItem2.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot.png")
        hotSpotItem2.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem2)        
 
        overlay.create
        overlayTLBData.save
        set overlayTLBData = nothing

        createScriptWrapper gfs.buildPath(overlay.path, "Show Caption.wsf"), "showCaption.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Edit Mode.wsf"), "editMode.vbs"
'        createScriptWrapper gfs.buildPath(overlay.path, "Delete Tile.wsf"), "deleteTile.vbs"

        set sc = gws.createShortcut(gfs.buildPath(overlay.path, "Delete Tile.lnk"))    
        sc.targetpath = """" & gfs.buildPath(FLD_SCRIPTS, "deleteTile.vbs") & """"
        sc.arguments =  """" & me.fullpath & """"
        sc.workingdirectory = FLD_HOME
        sc.save
        
        set hotSpotScript = new_CFile(gfs.buildPath(overlay.path, "Tile.wsf"))
        createScriptWrapper hotSpotScript.fullPath, "setTile.vbs"
        hotSpotScript.setHidden

        set hotSpotShortcut = gws.createShortcut(gfs.buildPath(overlay.path, "Tile.lnk"))
        hotSpotShortcut.targetPath = hotSpotScript.fullPath
        hotSpotShortcut.description = "Drop something here to create a tile"
        hotSpotShortcut.save        
        set hotSpotShortcut = nothing

    end sub

    
    private sub createEditOverlay

        set overlay = new_CTLBFolder(gfs.buildPath(fullPath, "Edit"))
        set overlayTLBData = new_CTLBData(overlay.tlbdata)
        overlayTLBData.options.setAttribute "skin", F_OVERLAYSKIN
        overlayTLBData.options.setAttribute "IconSize", "96"       
        overlayTLBData.options.setAttribute "ViewStyle", "2"
        overlayTLBData.options.setAttribute "ViewMode", "2" 
        overlayTLBData.options.setAttribute "skinvalid", "1"
        overlayTLBData.options.setAttribute "menuAlign", "102"
        overlayTLBData.options.setAttribute "showCaption", "0"
        overlayTLBData.options.setAttribute "Columns", "8"      

        set item = overlayTLBData.newItem("Show Caption.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "showcaption.png")
        overlayTLBData.appendItem(item)
        set item = nothing

        set item = overlayTLBData.newItem("Keep.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "tick.png")
        overlayTLBData.appendItem(item)      
        set item = nothing
        
        set item = overlayTLBData.newItem("Discard.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "cross.png")
        overlayTLBData.appendItem(item)
        set item = nothing        

        set item = overlayTLBData.newItem("Add alternate.wsf")
        item.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "plus.png")
        overlayTLBData.appendItem(item)          
        item.setAttribute "hidden", "1"
        set item = nothing
        
        set separator = overlayTLBData.newItem("**")
        overlayTLBData.appendItem(separator)

        set hotSpotItem1 = overlayTLBData.newItem("Size")
        hotSpotItem1.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot1.png")
        hotSpotItem1.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem1)        

        set hotSpotItem2 = overlayTLBData.newItem("Icon")
        hotSpotItem2.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot2.png")
        hotSpotItem2.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem2)        

        set hotSpotItem3 = overlayTLBData.newItem("Color")
        hotSpotItem3.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot3.png")
        hotSpotItem3.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem3)
        
        set separator = overlayTLBData.newItem("**")
        overlayTLBData.appendItem(separator)        

        set hotSpotItem4 = overlayTLBData.newItem("Caption")
        hotSpotItem4.setAttribute "ImagePath", gfs.buildPath(FLD_IMAGES, "hotSpot4.png")
        hotSpotItem4.setAttribute "showCaption", "1"
        overlayTLBData.appendItem(hotSpotItem4)            
        
  
        overlay.create
        overlayTLBData.save
        set overlayTLBData = nothing

 
        createScriptWrapper gfs.buildPath(overlay.path, "Show Caption.wsf"), "showCaption.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Keep.wsf"), "keep.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Discard.wsf"), "discard.vbs"
        createScriptWrapper gfs.buildPath(overlay.path, "Add alternate.wsf"), "addAlternate.vbs"
        
'         set hotSpotScript = new_CFile(gfs.buildPath(overlay.path, "hotSpot1.wsf"))
'         createScriptWrapper hotSpotScript.fullPath, "null.vbs"
'        hotSpotScript.setHidden
         
         createSizeFolder(gfs.buildPath(overlay.path, "Size"))
         createIconFolder(gfs.buildPath(overlay.path, "Icon"))
         createColorFolder(gfs.buildPath(overlay.path, "Color"))
         createCaptionFolder(gfs.buildPath(overlay.path, "Caption"))
         
     end sub

     private sub createColorFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)
         newFolderTLBData.options.setAttribute "skin", F_ICONSMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "26"       
         newFolderTLBData.options.setAttribute "disableTips", "1"
         newFolderTLBData.options.setAttribute "ViewStyle", "1"
         newFolderTLBData.options.setAttribute "ViewMode", "4" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "8482"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "3"      
         

         newFolderTLBData.save
         
     end sub

     private sub createCaptionFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)
         newFolderTLBData.options.setAttribute "skin", F_TEXTMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "24"       
 '        newFolderTLBData.options.setAttribute "ViewStyle", "2"
         newFolderTLBData.options.setAttribute "ViewMode", "5" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "13056"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "1"      
         
         newFolderTLBData.save
     
     end sub

     
     
     private sub createSizeFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)

         newFolderTLBData.options.setAttribute "skin", F_TEXTMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "16"       
'        newFolderTLBData.options.setAttribute "ViewStyle", "2"
         newFolderTLBData.options.setAttribute "ViewMode", "5" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "8465"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "1"    

        newFolderTLBData.options.setAttribute "maxMenuWidth", "125"
        newFolderTLBData.options.setAttribute "maxMenuHeight", "0"
        newFolderTLBData.options.setAttribute "minMenuWidth", "125"
        newFolderTLBData.options.setAttribute "minMenuHeight", "0"         
         
         set item = newFolderTLBData.newItem("Over size.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing        
        
         set item = newFolderTLBData.newItem("Full.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing
         
         set item = newFolderTLBData.newItem("Normal.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing
         
         set item = newFolderTLBData.newItem("Small.wsf")
         newFolderTLBData.appendItem(item)
         set item = nothing

         newFolderTLBData.save

         createScriptWrapper gfs.buildPath(newFolder.path, "Full.wsf"), "full.vbs"
         createScriptWrapper gfs.buildPath(newFolder.path, "Normal.wsf"), "normal.vbs"
         createScriptWrapper gfs.buildPath(newFolder.path, "Small.wsf"), "small.vbs"         
         createScriptWrapper gfs.buildPath(newFolder.path, "Over size.wsf"), "overSize.vbs"   
         
    end sub
    
    
      private sub createIconFolder(pPath)
     
         set newFolder = new_CTLBFolder(pPath)
         newFolder.create
         set newFolderTLBData = new_CTLBData(newFolder.tlbdata)
         newFolderTLBData.options.setAttribute "skin", F_TEXTMENUSKIN
         newFolderTLBData.options.setAttribute "IconSize", "48"       
         newFolderTLBData.options.setAttribute "disableTips", "1"
         newFolderTLBData.options.setAttribute "ViewStyle", "1"
         newFolderTLBData.options.setAttribute "ViewMode", "4" 
         newFolderTLBData.options.setAttribute "skinvalid", "1"
         newFolderTLBData.options.setAttribute "menuAlign", "13056"
         newFolderTLBData.options.setAttribute "showCaption", "0"
         newFolderTLBData.options.setAttribute "Columns", "1"    
         
         newFolderTLBData.save
     
    end sub
       
    
    public sub create

        createTile

        createTileOverlay
       
        createEditOverlay

        
    end sub


    public sub setTarget(pTarget)

        dim target
        set target = new_CFile(pTarget)

        dim link
        set link = nothing
        if target.extension = "lnk" or target.extension = "url" then
            set link = gws.createShortcut(target.fullpath)
            set app = new_CFile(link.targetPath)
        else
            set app = target
        end if    

        iconLoc = target.fullPath
        
        set iconLocObj = new_CFile(iconLoc)
        
        dim extractedIconLocation
        set extractedIconLocation = new_CFile(gfs.buildPath(gfs.buildPath(FLD_ICONS, app.name), app.name & ".png"))
        
        if not gfs.FolderExists(extractedIconLocation.folder) then
            gfs.createFolder extractedIconLocation.folder
        end if  
        
        if iconLocObj.extension = "ico" then
            iconIndex = mbg.icoFile_getBestIconIndex(iconLocObj.fullpath)
            mbg.ico2png iconLocObj.fullpath, iconIndex, extractedIconLocation.fullPath
        else
            if not mbg.extractIcon(iconLoc, extractedIconLocation.fullpath) then
                msgbox "no icons found in  " & icon.FullPath
            end if
        end if

        set tileColor = new_CFile(gxfs.getRandomFile(FLD_ACCENTS))        
        
        dim tlbdata3
        set tlbdata3 = new CTLBData
        tlbdata3.load me.tlbdata  

        
        gfs.copyFile extractedIconLocation.fullPath, me.originalIcon, true
        mbg.resizeIcon extractedIconLocation.fullpath, "96x96", me.icon
        gfs.copyFile tileColor.fullPath, me.bg, true
        ret = mbg.createTile (me.icon, target.name, me.bg, me.btnImage) 

    
        gfs.copyFile me.btnImage, me.editBtnImage, true

        set link = new_CFile(gfs.buildPath(me.fullPath, "Tile\Tile.lnk"))

        tlbdata3.setItemImagePath "Tile", me.btnImage
        tlbdata3.setItemImagePath "Edit", me.editBtnImage    

        tlbdata3.save
        set tlbdata3 = nothing
            
        set tlbdata3 = load_CTLBData(gfs.buildPath(link.folder, "tlbdata.xml"))
        tlbdata3.setItemAttribute "Tile.lnk", "leftText", target.name
        tlbdata3.showItem "Edit Mode.wsf"
        tlbdata3.save
        set tlbdata3 = nothing

        set shortcut2 = gws.createShortcut(link.fullpath)
        shortcut2.targetpath = target.fullpath
        shortcut2.description = target.name
        shortcut2.save

        
    end sub
    
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "icon: " & icon & vbcrlf & _
                    "bg: " & bg & vbcrlf & _
                    "btnImage: " & btnImage & vbcrlf & _
                    "fullPath: " & fullPath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTile" 
        
    end sub 'show
           
end class 


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
'**** END INCLUDED FILE: classes\_CTile.vbs ****



set script = new_CFile(wscript.scriptFullName)
set bg = new_CFile(gfs.buildPath(FLD_ACCENTS, script.name & ".png"))

set tile = load_CTile(gfs.getParentFolderName(gfs.getParentFolderName(script.folder)))

set tlbdata = load_CTLBData(gfs.buildPath(tile.fullPath, "Tile\tlbdata.xml"))
desc = tlbdata.getItemAttribute("Tile.lnk", "leftText")
'set sc = gws.createShortcut(tile.shortcut)
'desc = sc.description
'set sc = nothing

'mbg.resizeIcon icon.fullpath, "150x150", icon.fullpath 
ret = mbg.createTile (tile.icon, desc, bg.fullpath, tile.editBtnImage) 
    
gws.sendkeys "{LEFT}"
gws.sendKeys HK_REFRESH

