'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Tiles
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "Tiles") 
FLD_TOOLBARS = gfs.buildPath(FLD_HOME, "toolbars")
FLD_MAINTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Main")
FLD_TILESTOOLBAR = gfs.buildPath(FLD_TOOLBARS, "Tiles")

FLD_TILESMENU = gfs.buildPath(FLD_MAINTOOLBAR, "Tiles")

FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_IMAGES = gfs.buildPath(FLD_HOME, "images")
FLD_ICONS = gfs.buildPath(FLD_HOME, "icons")
FLD_TILES = gfs.buildPath(FLD_HOME, "tiles")
FLD_ACCENTS = gfs.buildPath(FLD_HOME, "accents")

'Skins
F_TILESKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles\tlbskin.ini")
F_MAINSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (main)\tlbskin.ini")
F_OVERLAYSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (overlay)\tlbskin.ini")
F_ICONSMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu icons)\tlbskin.ini")
F_TEXTMENUSKIN = gfs.buildPath(FLD_TLBSKINS, "Tiles (menu text)\tlbskin.ini")

F_TILEICON = gfs.buildPath(FLD_METROBARIMAGES, "tile.ico")
F_METROBARINI = gfs.buildPath(FLD_HOME, "metrobar.ini")

' Metrics
TILESIZE = 160  

' Hotkeys
HK_ACTIVATETILEBAR = "^%p"       ' CTRL+ALT+p
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_SHOWTILES = "^%+{right}"
HK_TEAROFF = "^t"

' Functions
function intToTileName(pInt)
    intToTileName = "Tile" & CStr(pInt)
end function    

sub refresh
    gws.sendkeys HK_ACTIVATETILEBAR
    wscript.sleep 20
    gws.sendkeys HK_REFRESH
end sub


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function lft(pString, pLength)

    lft = ""
    if pLength > 0 then
        lft = left(pString, pLength)
    elseif pLength < 0 then
        lft = left(pString, len(pString) + pLength)
    end if    

end function

function isTile(pPath)

    isTile = gfs.folderExists(pPath) AND isNumeric(gfs.getBaseName(pPath))

end function
    

Function IsValue(obj)
    ' Check whether a value has been returned.
    Dim tmp
    On Error Resume Next
    tmp = " " & obj
    If Err <> 0 Then
        IsValue = False
    Else
        IsValue = True
    End If
    On Error GoTo 0
End Function
'**** END INCLUDED FILE: classes\_global.vbs ****

'**** INCLUDED FILE: classes\_CFile.vbs ****


function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function
    
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    
'**** END INCLUDED FILE: classes\_CFile.vbs ****


set script = new_CFile(wscript.scriptFullName)
set fld = gfs.getFolder(gfs.buildPath(script.folder, "Files"))
for each f in fld.subFolders
    gfs.copyFolder f, FLD_TLBSKINS & "/", false
next

createScriptWrapper gfs.buildPath(FLD_MAINTOOLBAR, "Show Tiles.wsf"), "showTiles.vbs"  
createScriptWrapper gfs.buildPath(FLD_MAINTOOLBAR, "Hide Tiles.wsf"), "hideTiles.vbs"  

createScriptWrapper gfs.buildPath(FLD_TILESMENU, "New Tile.wsf"), "newTile.vbs"  
createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Align Tiles.wsf"), "alignTiles.vbs"  
createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Show Captions.wsf"), "showCaptions.vbs"  
createScriptWrapper gfs.buildPath(FLD_TILESMENU, "Hide Captions.wsf"), "hideCaptions.vbs"

